<?php
require_once "sqliteDB.php";

define('TRY_INSERT',1);
define('TRY_UPDATE',1);

$jobrunningDir = shell_exec('pwd');
$jobrunningDir = trim($jobrunningDir);

$exit_flag = 0;
$skip = 0;
$fileBackupCount = 0;
$fileSyncCount = 0;
$failedfiles_count = 0;
$failedfiles_index = 0;
$sleep_count = 0;
$current_BackupsetHash = array();
$localBackupHash = array();

$retry_info = "./retry_info";
$operationComplete = "100%";

$retryAttempt = false;
$failedfiles_array = array();
$fileJobTerminationPath = $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR.SCRIPTS.PATHSEPARATOR.JOBTERMINATIONFILE;

# parameters sent with the script calling
$logOutputFilePath = $argv[1];						   
$current_backupsetfile = $argv[2];
$relative = $argv[3];
$current_source = $argv[4];
$backupLocation = base64_decode($argv[5]);
$backup_error = $current_backupsetfile."_ERROR";
$matchedXMLcount = 0;
$dbh_insert = '';
$dbh_update = '';
$selectFolderCount = '';
$dbh_ibFolder_insert = '';
$dbh_ibFile_insert   = '';
$dbh_ibFolder_update = '';
$dbh_ibFile_update = '';
$opStartTime = $argv[6];
//$opStartTime = time();
$fileCount = 0;

# Errors encountered during backup operation for which the script should not retry the backup operation                         
$ErrorArgumentsNoRetry = array("No such file or directory",
                             "File name too long",
							 "skipping non-regular file",
							 "Permission Denied",
							 "SFERROR",
                             "IOERROR",
                             "mkstemp"
							);	
							
# Errors encountered during backup operation for which the script should not retry the backup operation                         
$ErrorArgumentsExit = array(  "encryption verification failed",
                             "some files could not be transferred due to quota over limit",
                             "skipped-over limit",
                             "account is under maintenance",
                             "account has been cancelled",
                             "account has been expired",
                             "protocol version mismatch",
                             "password mismatch",
							 "not enough free space on device",
                             "No route to host",
                             "bad response from proxy",
                             "out of memory",
							 "failed to get the device information"
                            );
						
# Errors encountered during backup operation for which the script should retry the backup operation                          
$ErrorArgumentsRetry = array("io timeout",
                           "Operation timed out",
                           "nodename nor servname provided, or not known",
                           "failed to connect",
						   "connection unexpectedly closed",
                           "Connection refused",
						   "failed verification -- update",
						   "unauthorized user"
                          );

$statusFileHash = array();

$currentBackupset = file($current_backupsetfile);	
if(!$currentBackupset){
	$errStr = "Unable to open current backupset file $current_backupsetfile. Reason: ".customErrorMsg()."\n";
	traceLog($errStr);	
	writeBackupErrorMsgToStatusFile($errStr);
	exit;
}

foreach($currentBackupset as $item){
	$item = trim($item);
	if($item != "")
		$current_BackupsetHash[$item] = 0;
}	

# signal handlers
if(function_exists('pcntl_signal')){
	declare(ticks = 1); //To handle signals (Kill/Term/..etc)
	pcntl_signal(SIGINT, 'process_term');
	pcntl_signal(SIGTERM, 'process_term');
}

if($isLocalBackup == 0 ){			#Online backup for two tier
	if(!createDB()){
		$errStr = "Create DB failed. Reason: ".$e->getMessage();
		traceLog($errStr);
		writeBackupErrorMsgToStatusFile($errStr);
		exit;
	}
	try{
		$dbh_insert = $dbh->prepare("INSERT INTO IDriveLocalTable (FILEPATH, MOD_DT, FILESIZE, LEVELCOUNT) values (?,?,?,?)") ;
		$dbh_update = $dbh->prepare("UPDATE IDriveLocalTable SET MOD_DT = ?, FILESIZE = ? , PRESENTDATE = ? , LEVELCOUNT = ? WHERE FILEPATH = ?");
	}
	catch(PDOException $e){
		$errStr = "Error: Prepare statement failed for insert/update. Reason: ".$e->getMessage();
		traceLog($errStr);
		writeBackupErrorMsgToStatusFile($errStr);
		unset($dbh);
		exit;
	}
	subOutputProcess();
	unset($dbh);
	subErrorRoutine();
} 
else if($isLocalBackup == 1) {			#local backup for two tier
	#Local backup	
	$res = "";
	if(!createLBDB()){
		$errStr = "Create LBDB failed.";
		traceLog($errStr);
		writeBackupErrorMsgToStatusFile($errStr);
		set($backupSQLite);
		exit;
	}
	
	$ibFolder = "ibfolder";
	$ibFile = "ibfile";
	try{
		$selectFolderCount = $dbh_LB->prepare("SELECT DIRID FROM $ibFolder WHERE NAME=?");
		$dbh_ibFolder_insert = $dbh_LB->prepare("INSERT INTO $ibFolder (NAME,FILE_LMD,FILE_SIZE,SYNC_DATE) values (?,?,?,?)");
		$dbh_ibFile_insert   = $dbh_LB->prepare("INSERT INTO $ibFile (DIRID,NAME,FILE_LMD,FILE_SIZE,BKSET_LMD,SYNC_DATE,BKSET_NAME,HASH_VALUE,FOLDER_ID,MPC,ENC_NAME,FILE_OR_FOLDER,BACKUP_STATUS) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?)");
		$dbh_ibFolder_update = $dbh_LB->prepare("UPDATE $ibFolder SET FILE_LMD=? WHERE NAME=?");
		$dbh_ibFile_update = $dbh_LB->prepare("UPDATE $ibFile SET FILE_LMD=?,FILE_SIZE=? WHERE NAME=? AND FOLDER_ID=?") ;
	}
	catch (PDOException $e){
		$errStr = "Error: Prepare statement failed for insert/update for Local Backup, ".customErrorMsg();
		traceLog($errStr);
		writeBackupErrorMsgToStatusFile($errStr);
		
		if($dbh_LB)
			unset($dbh_LB);	
		set($backupSQLite);
		exit;
	}

	subXMLOutputProcess();
	subErrorRoutine();
	if($dbh_LB)
		unset($dbh_LB);
}
else{		#Online backup for other NASs
	subOutputProcess();                                                                                    
	subErrorRoutine();    
}

writeParameterValuesToStatusFile();

#****************************************************************************************************
# Subroutine Name         : subOutputProcess.
# Objective               : This function monitors and parse the evs output file and creates the user  
#							log file. 					
# Added By                : Senthil Pandian [11/25/2016]
# Modified By			  : 
#*****************************************************************************************************/
function subOutputProcess()
{
	GLOBAL $dbh,$skip,$opStartTime,$isLocalBackup,$logOutputFilePath;
	GLOBAL $backup_error,$operationComplete,$current_backupsetfile;
	GLOBAL $backupLocation,$current_BackupsetHash;
	GLOBAL $lastLine;
	
	# Flags to determine the status of OUTFILE 
	$fileOpened = 0;
	$termData = "CHILD_PROCESS_COMPLETED";
	$buffer = "";
	$byteRead = 0;
	$lastLine  = "";
	$fields_in_progress = 10;

	# Waiting for EVS output file to open
	while(!$fileOpened){
		if(!file_exists(PIDFILE))
			break;
		
		if(file_exists(OUTPUTFILE)){
			if($handle = fopen(OUTPUTFILE,'r'))
				$fileOpened = 1;
			else 
				break;
		}
		sleep(2);
	}
	
	if(!$fileOpened){		
		traceLog("Could not open file : ".OUTPUTFILE.customErrorMsg());
		return;
	}

	# App log file open for parsed output
	if(!$logOutputHandle = fopen($logOutputFilePath,'a')){
		traceLog("Could not open $logOutputFilePath, Reason : ".customErrorMsg());
		return;
	}	
	
	$Backuptype ="";
	if($isLocalBackup == 0)
		$dbh->beginTransaction();
	
	$prevTransferedSize = 0;
	$totalTransfered = 0;
	$fileCount = 0;
	
	if(file_exists(PROGRESS_PATH) and customFileSize(PROGRESS_PATH)>0){
		$progressContent = file_get_contents(PROGRESS_PATH);	
		$progressContent = explode("\n",$progressContent);
		$totalTransfered = isset($progressContent[3])?$progressContent[3]:'';		
	}
	
	while(1){
		$buffer = fread($handle, LIMIT);
		$buflen = strlen($buffer);  //<DEEPAK> print to check if it is able to read the 10k every time.

		if(0 === $buflen){			
			if(!file_exists(PIDFILE)){
				break;
			}			
			sleep(WAIT_FOR);
			fseek($handle, 0, 1);		//to clear eof flag
			continue;
		}
		
		//need to check appending partial record to packet or to first line of packet
		if("" != $lastLine)
			$buffer = $lastLine.$buffer;			

		if(!preg_match('/\n$/', $buffer)){
			$lastNewlinePos = strrpos($buffer, "\n");
			$resultList = substr($buffer,0,$lastNewlinePos);
			$lastLine   = substr($buffer,$lastNewlinePos);
		} 
		else {
			$resultList = $buffer;
			$lastLine = '';
		}
		
		$noOfLines  = substr_count($resultList,"\n");
		$resultListXML = "<root>$resultList</root>";
		$xml = simplexml_load_string($resultListXML);
		if(!$xml){
			$resultListXML = checkAndConstructXML($resultList);
			$resultListXML = "<root>$resultListXML</root>";
			$xml = simplexml_load_string($resultListXML);
		}
		
		$toCheck = 0;
		foreach ($xml->item as $value)
		{
			$type 				= trim($value['trf_type']);
			$fileName 			= trim($value['fname']);
			$size 			    = trim($value['size']);
			$transferedSize		= trim($value['tottrf_sz']);
			$rateOfTransfer    	= trim($value['rate_trf']);	
			$percentage	    	= trim($value['per']);

			# calculate transfered file size for specfic file
			if($transferedSize == 0 && $type == "FILE IN SYNC"){
				$totalTransfered += $size;
				$prevTransferedSize = 0;
			}
			else{
				$totalTransfered += $transferedSize - $prevTransferedSize;
				$prevTransferedSize = $transferedSize;
			}				
			
			updateProgressFile($type, $fileName, $size, $totalTransfered, $rateOfTransfer, $opStartTime);
			if($percentage == $operationComplete) {
				$keyString = PATHSEPARATOR.$fileName;
				
				if($isLocalBackup == 0){
					$localFilePath	= getLocalFilePath($keyString);
					$size 			= customFileSize($localFilePath);
					$modtime 		= filemtime($localFilePath);
					$fileInsert 	= "$backupLocation$keyString";		
				}
				
				$Backuptype ="";					
				if($type == "FILE IN SYNC")
					$Backuptype = "Sync";
				else if($type ==  "FULL")
					$Backuptype = "Full Backup";
				else if($type ==  "INCREMENTAL")
					$Backuptype = "Incremental Backup";
				else{
					if($percentage == "")
						addtionalErrorInfo($percentage,$backup_error);
				}
				
				if($Backuptype != ""){
					if(isset($current_BackupsetHash[$keyString])){
						if($Backuptype == "Sync")
							$current_BackupsetHash[$keyString] = 2;
						else
							$current_BackupsetHash[$keyString] = 1;
					}
					else
						getFullPathofFile($keyString, $type);
					
					$fileCount++;
					if($isLocalBackup == 0){
						$levelCount = substr_count($fileInsert,"/");
						if($Backuptype == "Full Backup")
							insert(1, $fileInsert,$modtime,$size, $levelCount-1);
						else
							update(1, $modtime, $size, time(), $levelCount-1, $fileInsert);
					}
					
					if($Backuptype != "Sync"){
						//$backupFinishTime = date("D M d H:i:s Y"); //Ex: Sat Feb 16 06:50:45 2013
						$backupFinishTime = trim(shell_exec('date +"%a %b %d %T %Y"')); //Ex: Sat Feb 16 06:50:45 2013
						$fileSize = convertFileSize($size);    
					
						if(strstr($current_backupsetfile,"_onlyFiles")){
							$pos = strrpos($fileName, '/');
							$fileName = substr($fileName,$pos+1);
						}
						fwrite($logOutputHandle,"[$backupFinishTime] [$Backuptype] [SUCCESS] [".PATHSEPARATOR."$fileName] [$fileSize]".LINEFEED);							
					}
					
					if($fileCount % 1000 == 0){
						if($isLocalBackup == 0){
							$dbh->commit();
							$dbh->beginTransaction();
						}
						$fileCount = 0;
					}
				}
			}
			$toCheck++;
		}
		
		if(strstr($resultList,$termData)) {
			@unlink(OUTPUTFILE);
			$skip = 1;
			break;
		} 
		else if($noOfLines>$toCheck){
			$exp  = explode("\n",$resultList);
			foreach($exp as $data){
				$data = trim($data);
				if(!empty($data) && strpos($data,"<item")===false && strpos($data,"offset=")===false && strpos($data,'building file list') === false && strpos($data,'connection established') === false && strpos($data,'bytes  received') === false)
					addtionalErrorInfo($data,$backup_error);
			}
		}
		if($skip == 1){
			$skip = 0;
			break;
		}		
    }	
	fclose($logOutputHandle);
	fclose($handle);
	@chmod($logOutputFilePath,PERMISSIONVAL);
	if($isLocalBackup == 0 && $fileCount > 0){
		$dbh->commit();	
	}
}

#****************************************************************************************************
# Subroutine Name         : subXMLOutputProcess.
# Objective               : This function monitors and parse the evs output file(XML content) and creates the App 
#							log file which is shown to user. 					
# Added By                : Senthil Pandian [11/30/2016]
# Modified By			  : 
#*****************************************************************************************************/
function subXMLOutputProcess()
{
	GLOBAL $dbh_LB,$logOutputFilePath,$opStartTime,$isLocalBackup, $current_BackupsetHash;
	GLOBAL $skip,$current_backupsetfile,$backup_error;
	
	# Flags to determine the status of OUTFILE 
	$fileOpened = 0;
	$termData = "CHILD_PROCESS_COMPLETED";
	$buffer = "";
	$byteRead = 0;
	$lastLine  = "";
	$fields_in_progress = 20;
	$fileVersion = "file_ver=";
	$fileName  = "";
	$fileCount = 0;

	# Waiting for EVS output file to open
	while(!$fileOpened){
		if(!file_exists(PIDFILE)){
			break;
		}

		if(file_exists(OUTPUTFILE)){
			if($handle = fopen(OUTPUTFILE,'r')){
				$fileOpened = 1;
			} else {
				break;
			}
			sleep(2);
		}
	}
	
	if(!$fileOpened){		
		traceLog("Could not open ".OUTPUTFILE.customErrorMsg());
		return;
	}

	# App log file open for parsed output
	if(!$logOutputHandle = fopen($logOutputFilePath,'a')){
		traceLog("Could not open $logOutputFilePath, Reason : ".customErrorMsg());
		return;
	}
	
	$dbh_LB->beginTransaction();
	while (1)
    {
		$buffer = fread($handle, LIMIT);
		$byteRead = strlen($buffer);
		
		if($byteRead == 0){
			if(!file_exists(PIDFILE)){
				break;
			}			
			sleep(WAIT_FOR);
			fseek($handle, 0, 1);		//to clear eof flag
			continue;
		}
	
		//need to check appending partial record to packet or to first line of packet
		if("" != $lastLine){
			$buffer = $lastLine.$buffer;
		}

		if(!preg_match('/\n$/', $buffer)){
			$lastNewlinePos = strrpos($buffer, "\n");
			$resultList = substr($buffer,0,$lastNewlinePos+1);
			$lastLine   = substr($buffer,$lastNewlinePos+1);
		} else {
			$resultList = $buffer;
			$lastLine = '';
		}
		$noOfLines  = substr_count($resultList,"\n");
		$resultListXML = "<root>$resultList</root>";
		$xml = simplexml_load_string($resultListXML);
		if(!$xml){
			$resultListXML = checkAndConstructXML($resultList);
			//$resultListXML = "<root>".utf8_encode($resultListXML)."</root>";//Commented by Senthil w.r.t Multi-language issue
			$resultListXML = "<root>$resultListXML</root>";
			$xml = simplexml_load_string($resultListXML);
		}
		$toCheck = 0;

		foreach ($xml->item as $value)
		{
			$fieldSize 	   = trim($value['size']);
			$fieldTRFType  = trim($value['trf_type']);
			$fieldFolderId = trim($value['folder_id']);
			$fieldMPC 	   = trim($value['mpc']);
			$fieldEncName  = trim($value['enc_name']);
			$fieldFileName = trim($value['fname']);
			$keyString = $fieldFileName;
			
			replaceXMLcharacters($keyString,BACKUP);
			$localFilePath = getLocalFilePath($keyString);
			$modtime = date("Y/m/d H:i:s A", filemtime($localFilePath));
			$Backuptype ="";
			
			if($fieldTRFType == "FILE IN SYNC"){
				$Backuptype = "Sync";
				$current_BackupsetHash[$keyString] = 2;
			}
			else if($fieldTRFType == "FULL"){
				$Backuptype = "Full Backup";
				$fileName = substr($fieldFileName,strrpos($fieldFileName, '/')+1);
			}
			else if($fieldTRFType == "INCREMENTAL"){
				$Backuptype = "Incremental Backup";
				$fileName = substr($fieldFileName,strrpos($fieldFileName, '/')+1);
			}
			
			if($Backuptype == "Sync"){
				continue;
			}
			
			if($Backuptype != ""){
			//$backupFinishTime = date("D M d H:i:s Y");
			$backupFinishTime = trim(shell_exec('date +"%a %b %d %T %Y"'));
			if(strstr($current_backupsetfile,"_onlyFiles")){
				$pos = strrpos($filename, '/');
				$fieldFileName = substr($fieldFileName,$pos+1);
			}
			$fileSize = convertFileSize($fieldSize);
				if($current_BackupsetHash[$keyString] == 0){
					fwrite($logOutputHandle,"[$backupFinishTime] [$Backuptype] [SUCCESS] [$fieldFileName] [$fileSize]".LINEFEED);
					$current_BackupsetHash[$keyString] = 1;
					getFullPathofFile($keyString, $type);
				}
			}	
				replaceXMLcharacters($fileName,BACKUP);
				$fileName = "'$fileName'";
				if($Backuptype == "Full Backup"){
					//Needs to be modified
					$dirID = folderExistenceinDB($keyString, $fieldMPC);
					if(!$dirID){
						$dirID = insertFolders($keyString, $fieldMPC);
					}					
					insertIbFile(1, $dirID,$fileName,$modtime,$fieldSize,'NA','NA',"Default Backupset",'0',$fieldFolderId,$fieldMPC,$fieldEncName, '1', '1');					
				} else{
					$keyString = substr($keyString,0,strrpos($keyString, '/'))."/";
					$dirID = getDirID($keyString, $fieldMPC);
					updateIbFile(1, $modtime, $fieldSize, $fileName, $fieldFolderId, $dirID, $fieldMPC, $fieldEncName);
				}
				$fileCount++;
				if($fileCount % 1000 == 0){
					$dbh_LB->commit();
					$dbh_LB->beginTransaction();
					$fileCount = 0;
				}				
			$toCheck++;
		}
		
		if(strstr($resultList,$termData)) {
			@unlink(OUTPUTFILE);
			$skip = 1;
			break;
		}  
		else if($noOfLines > $toCheck){
			$exp  = explode("\n",$resultList);
			foreach($exp as $data){
				if(strpos($data,'building file list') === false && strpos($data,'connection established') === false && strpos($data,'bytes  received') === false){
					addtionalErrorInfo($data,$backup_error);
					$skip = 1;
				}
			}
		}
		
		if($skip == 1){
			$skip = 0;
			break;
		}				
	}
	
	fclose($logOutputHandle);
	fclose($handle);
	@chmod($logOutputFilePath,PERMISSIONVAL);
	
	if($fileCount > 0)
		$dbh_LB->commit();	
}

#********************************************************************************************************
# Subroutine Name         : folderExistenceinDB
# Objective               : This subroutine checks whether the folder path already exists in the DB, 
#							and if it does, updates entry and returns the resp dirID 
# Added By                : Pooja Havaldar [12/01/2016]
# Modified By			  : Senthil Pandian
#*********************************************************************************************************
function folderExistenceinDB($keyString)
{
	GLOBAL $localBackupHash;
	$fieldMPC = "/".$keyString;
	$keyString = substr($keyString,0,strrpos($keyString, '/'))."/";
	$searchItem = "'".$fieldMPC.$keyString."'";
	if(isset($localBackupHash[$searchItem])){
		return $localBackupHash[$searchItem];
	}
	$dirID = getDirID($keyString, $fieldMPC);
	if($dirID){
		$localBackupHash[$searchItem] = $dirID;
	}		
	return $dirID;
}

#*****************************************************************************************************************************************
# Subroutine Name         : insertFolders
# Objective               : This subroutine makes level by level folder entry into the DB and returns the dirID of the full folder path
# Added By                : Pooja Havaldar
# Modified By			  : Senthil Pandian
#*****************************************************************************************************************************************/
function insertFolders($keyString,$fieldMPC)
{	
	GLOBAL $dbh_LB,$localBackupHash,$fileCount;
	
	$mpcName = "/".$fieldMPC;
	$folderPath = substr($keyString,0,strrpos($keyString, '/'))."/";
	$array = explode('/', $folderPath);
	
	for($index = count($array)-1; $index >= 0; $index--){
		$keyString = substr($keyString,0,strrpos($keyString, '/'));
		$string = $keyString."/";
		$searchItem = "'$mpcName$string'";
		
		if(isset($localBackupHash[$searchItem])){
			break;
		}
		
		$dirID = getDirID($string, $mpcName);
		if(!$dirID){
			list($modtime, $fieldSize) = getSizeLMD($string);			
			insertIbFolder(1, $searchItem,$modtime,'0');			
			$fileCount++;
			if($fileCount % 1000 == 0){
				$dbh_LB->commit();
				$dbh_LB->beginTransaction();
				$fileCount = 0;
			}
			$dirID = getDirID($string, $mpcName);
			$localBackupHash[$searchItem] = $dirID;
		}
		else{
			$localBackupHash[$searchItem] = $dirID;
			break;
		}
	}
	
	$folderPath = "'".$mpcName.$folderPath."'";
	return $localBackupHash[$folderPath];;
}

#*******************************************************************************************************
# Subroutine Name         : getDirID
# Objective               : This subroutine returns the dirID of full folder path
# Added By                : Senthil Pandian [12/01/2016]
# Modified By			  : 
#********************************************************************************************************
function getDirID($keyString,$mpcName)
{
	GLOBAL $selectFolderCount;
	$finalPath = "'".$mpcName.$keyString."'";
	$selectFolderCount->execute(array($finalPath));
	$dir = $selectFolderCount->fetch();	
	$dirID = $dir['DIRID'];
	if($dirID == ""){
		$dirID = 0;
	}
	return $dirID; 
}

#**************************************************************************************************************************
# Subroutine Name         : getSizeLMD
# Objective               : This subroutine returns the modtime and size of file/folder path using the stat cmd
# Added By                : Senthil Pandian [12/01/2016]
# Modified By			  : 
#**************************************************************************************************************************
function getSizeLMD($filePath)
{
	$actualPath = getLocalFilePath($filePath);
	$modtime    = date("Y/m/d H:i:s A", filemtime($actualPath));
	$size       = customFileSize($actualPath);
	return array($modtime, $size);
}
#****************************************************************************************************
# Subroutine Name         : subErrorRoutine.
# Objective               : This function monitors and parse the evs output file and creates the App 
#							log file which is shown to user. 
# Added By                : Senthil Pandian	[12/01/2016]
# Modified By			  : 
#*****************************************************************************************************
function subErrorRoutine()
{
	GLOBAL $backup_error,$jobrunningDir, $retryAttempt,$failedfiles_array,$relative, $current_source;
	$failedfilesName = '';
	
	getFailedFileCount();
	
	#Copying evs generated error.txt to BACKUP_ERRORFILE
	copyTempErrorFile($backup_error);
	$failedfiles_index = getParameterValueFromStatusFile("FILE_COUNT_INDEX");

	$individual_errorfile = $jobrunningDir."/".ERROR_DIR."/$backup_error";
	
	if(file_exists($individual_errorfile) && customFileSize($individual_errorfile) > 0 and $failedfiles_index != -1){
		if(!checkretryAttempt($individual_errorfile)){
			getFinalErrorFile();
			updateFailedFileCount();
			return;
		}
	}
	else{
		getFinalErrorFile();
		updateFailedFileCount();
		return;
	}

	if(!$retryAttempt or $failedfiles_index == -1){
		getFinalErrorFile();
	}
	else{
		$failedfiles_index = getParameterValueFromStatusFile("FILE_COUNT_INDEX");
		if(count($failedfiles_array) > 0){
			$failedfiles_index++;
			$failedfilesName = TEMP_FILES."/failedfiles.txt".$failedfiles_index;
			$oldfile_error   = $jobrunningDir."/".ERROR_DIR."/$backup_error";
			$newfile_error   = $jobrunningDir."/".ERROR_DIR."/$failedfilesName"."_ERROR";
			
			if(file_exists($oldfile_error) or file_exists($oldfile_error."_FINAL")){
				shell_exec("mv '$oldfile_error' '$newfile_error'");
			}
			if(!$handle = fopen($failedfilesName,'w')){
				traceLog("Unable to open file $failedfiles, Reason : ".customErrorMsg());
				updateFailedFileCount();
				return;
			}

			for($i = 0; $i < count($failedfiles_array); $i++){
				fwrite($handle,"$failedfiles_array[$i]\n");
			}
			fclose($handle);
		}
		
		if(file_exists($failedfilesName)){
			$handle = fopen(RETRY_INFOFILE,'a');
			if(!$handle){
				traceLog("not open retry file. Reason: ".customErrorMsg());
			} else{
				fwrite($handle,"$failedfilesName $relative $current_source\n");
				fclose($handle);
			}
		}
	}
	updateFailedFileCount();
}

#****************************************************************************************************
# Subroutine Name         : checkretryAttempt.
# Objective               : This function checks whether backup has to retry   
# Added By                : Senthil Pandian [12/01/2016]
# Modified By			  : 
#*****************************************************************************************************
function checkretryAttempt($individual_errorfile)
{
	GLOBAL $ErrorArgumentsExit,$ErrorArgumentsRetry,$retryAttempt,$dedupDetailFile;
	$errorline = "idevs error";
	
	#check for retry attempt
	if(!$handle = fopen($individual_errorfile,'r')){
		traceLog("Unable to open file $individual_errorfile, Reason : ".customErrorMsg());
		return false;
	}
	$content = fread($handle, customFileSize($individual_errorfile));
	$linesBackupErrorFile = explode("\n",$content);
	fclose($handle);
	
	#To check the individual error file for exit scenarios
	if(count($linesBackupErrorFile)>0){
		for($i = 0; $i< count($linesBackupErrorFile); $i++){
			
			$tempLinesBackupErrorFile = trim($linesBackupErrorFile[$i]);
			
			if($tempLinesBackupErrorFile == "" or strstr($tempLinesBackupErrorFile,$errorline)){
				continue;
			}
			
			for($j=0; $j<count($ErrorArgumentsExit); $j++)
			{
				if(strstr($tempLinesBackupErrorFile,$ErrorArgumentsExit[$j]))
				{
					checkDedupDeviceError($tempLinesBackupErrorFile);
					@unlink(ERRORFILE);
					if(is_dir(EVS_TEMP))
						exec("rm -rf ".EVS_TEMP);

					$errStr = "Operation could not be completed. Reason : $ErrorArgumentsExit[$j] \n";
					traceLog($errStr);
					jobTerminate($ErrorArgumentsExit[$j]);
					return false;
				}
			}	
		}
		#To check the individual error file for retry case		
		for($i = 0; $i<count($linesBackupErrorFile); $i++){

			$tempLinesBackupErrorFile = trim($linesBackupErrorFile[$i]);
			if($tempLinesBackupErrorFile == "" or strstr($tempLinesBackupErrorFile,$errorline)){
				continue;
			}
			
			for($j=0; $j<count($ErrorArgumentsRetry); $j++){
				if(strstr($tempLinesBackupErrorFile,$ErrorArgumentsRetry[$j])){
					$retryAttempt = true;
					break;
				}
			}	
			if($retryAttempt){
				break;
			}
		}		
	}
	return true;
}

#****************************************************************************************************
# Subroutine Name         : process_term
# Objective               : The signal handler invoked when SIGTERM signal is received by the script       
# Added By                : Senthil Pandian [12/01/2016]
# Modified By			  : 
#*****************************************************************************************************
function process_term()
{
	GLOBAL $dbh_LB,$dbh,$fileCount;
	if($fileCount > 0){
		if($dbh_LB){
			$dbh_LB->commit();	
			unset($dbh_LB);
		}
		if($dbh){
			$dbh->commit();	
			unset($dbh);
		}
	}
	writeParameterValuesToStatusFile();
	exit;
}

#****************************************************************************************************
# Subroutine Name         : writeParameterValuesToStatusFile
# Objective               : This subroutine writes the value of the specified parameter to the Status File 
# Added By                : Senthil Pandian [12/01/2016]
# Modified By			  : 
#*****************************************************************************************************
function writeParameterValuesToStatusFile()
{
	GLOBAL $statusFileHash,$fileBackupCount,$fileSyncCount;
	GLOBAL $failedfiles_count,$failedfiles_index,$exit_flag;
	$Backupcount= 0;
	$Synccount = 0;
	$failedcount = 0;
	
	$Backupcount = getParameterValueFromStatusFile("BACKUP_COUNT_FILES_INDEX");
	$Synccount   = getParameterValueFromStatusFile("SYNC_COUNT_FILES_INDEX");
	$failedcount = getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");

	try{
		$handle = fopen(STATUSFILE,'w');
		# Calculate the backup, sync and error count based on new values
		$Backupcount += $fileBackupCount;
		$Synccount   += $fileSyncCount;
		$failedcount  = $failedfiles_count;	
		
		$content  = "BACKUP_COUNT_FILES_INDEX = $Backupcount \n";
		$content .= "SYNC_COUNT_FILES_INDEX = $Synccount \n";
		$content .= "FAILED_COUNT_FILES_INDEX = $failedcount \n";
		$content .= "FILE_COUNT_INDEX = $failedfiles_index \n";
		$content .= "EXIT_FLAG_INDEX = $exit_flag ";
		fwrite($handle,$content);
		fclose($handle);
		@chmod(STATUSFILE,PERMISSIONVAL);
		$statusFileHash = array();		
	} catch (Exception $e){
		traceLog("Unable to open file ".STATUSFILE.". Reason:".$e->getMessage());
	}
}

#*************************************************************************************************************************
# Subroutine Name       : getFullPathofFile
# Objective             : This subroutine gets the full path of files that have backed up 
# Added By              : Senthil Pandian [11/30/2016]
# Modified By			: 
#*************************************************************************************************************************
function getFullPathofFile($fileToCheck, $type)
{
	GLOBAL $currentBackupset,$current_BackupsetHash;
	$retStr = replaceXMLcharacters($fileToCheck,BACKUP);
	
	if($retStr)
		return;
	
	for($i = count($currentBackupset)-1; $i >= 0; $i--){
		$currentBackupset[$i] = trim($currentBackupset[$i]);
		$a = strrpos($currentBackupset[$i], '/');
		$match = substr($currentBackupset[$i],$a);
		$match = trim($match);

		if($fileToCheck == $match){
			if($type == "FILE IN SYNC")
				$current_BackupsetHash[$currentBackupset[$i]] = 2;
			else 
				$current_BackupsetHash[$currentBackupset[$i]] = 1;
			
			break;
		}
	}
}

#*************************************************************************************************************************
# Subroutine Name       : getFinalErrorFile
# Objective             : This subroutine creates a final ERROR file for each backupset, which has to be displayed in LOGS  
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#**************************************************************************************************************************
function getFinalErrorFile()
{	
	GLOBAL $exit_flag, $jobrunningDir, $backup_error, $failedfiles_count, $failedfiles_array;
	
	$cancel = 0;
	if($exit_flag == 0){
		if(!file_exists(PIDFILE)){
			$cancel = 1;
		}
	}
	$failedWithReason = 0;
	$errFinal = "";
	$errMsgFinal = "";
	$individual_errorfile = $jobrunningDir."/".ERROR_DIR."/$backup_error";
	if($failedfiles_count > 0){
		if(!$errorFinalHandle = fopen($individual_errorfile."_FINAL",'w')){
			traceLog("Unable to open $individual_errorfile"."_FINAL"."Reason : ".customErrorMsg());
			return;		
		}
		else {
			if(!file_exists($individual_errorfile) or !$backupErrorHandle = fopen($individual_errorfile,'r')){
				if($exit_flag != 0 or $cancel != 0){
					$failedfiles_count = $failedWithReason;
				}				
				if($cancel==1)
					traceLog("Unable to open $individual_errorfile.");
				return;				
			}
			$backupErrorContent = fread($backupErrorHandle, customFileSize($individual_errorfile));
			$individual_errorfileContents = explode("\n",$backupErrorContent);
			fclose($backupErrorHandle);	
		}
		
		$j = 0; 
		sort($failedfiles_array);
		$last_index = count($individual_errorfileContents)-1;
	
		for($i = 0; $i < count($failedfiles_array); $i++){
			$matched = 0;
			
			#reset the initial and last limit for internal for loop for new item if required
			if($j > $last_index){
				$j = 0;
				$last_index = count($individual_errorfileContents)-1;
			}
			
			#fill the last matched index for later use
			$index = $j;
			$failedfile = substr($failedfiles_array[$i],1);
			$failedfile = phpQuoteMeta($failedfile);
			
			#try to find a match between start and end point of error file
			//$localtime = date("D M d H:i:s Y");
			$localtime = trim(shell_exec('date +"%a %b %d %T %Y"'));
			for(;$j <= $last_index; $j++){
				if(preg_match("/$failedfile/", $individual_errorfileContents[$j])){
					$individual_errorfileContents[$j] = preg_replace("/\[.*\]\,/",'',$individual_errorfileContents[$j]);
					$individual_errorfileContents[$j] = preg_replace("/$failedfile/",'',$individual_errorfileContents[$j]);
					
					$errorFinalContent = "[$localtime] [FAILED] [$failedfiles_array[$i]] Reason : $individual_errorfileContents[$j] ".LINEFEED;
					fwrite($errorFinalHandle,$errorFinalContent);
					$matched = 1;
					$failedWithReason++;	
						
					#got a match so resetting the last index 
					$last_index = count($individual_errorfileContents)-1;
					$j++;
					break;
				}
				
				#if no match till last item and intial index is not zero try for remaining error file content
				if($j == $last_index && $index != 0){
					$j = 0;
					$last_index = $index;
					$index = $j;
				}
			}
			
			if($matched == 0 and $exit_flag == 0 and $cancel == 0){
				fwrite($errorFinalHandle,"[$localtime] [FAILED] [$failedfiles_array[$i]] ".LINEFEED);
			}
		}		
		fclose($errorFinalHandle);
	}
	
	if($exit_flag != 0 or $cancel != 0){
		$failedfiles_count = $failedWithReason;
	}
	@unlink($individual_errorfile);
}

#************************************************************************************************************************
# Subroutine Name       : getFailedFileCount
# Objective             : This subroutine gets the failed files count from the failedfiles array  
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#************************************************************************************************************************
function getFailedFileCount()
{
	GLOBAL $currentBackupset,$current_BackupsetHash,$failedfiles_array,$failedfiles_count, $fileBackupCount, $fileSyncCount;
	$j = 0;
	for($i = 0; $i < count($currentBackupset); $i++){
		$tempCurrentBackupset = trim($currentBackupset[$i]);
		if(empty($tempCurrentBackupset))
			continue;
		
		if($current_BackupsetHash[$tempCurrentBackupset] == 0){
			$failedfiles_array[$j] = $tempCurrentBackupset;
			$j++;
		}
		elseif($current_BackupsetHash[$tempCurrentBackupset] == 1)
			$fileBackupCount++;
		elseif($current_BackupsetHash[$tempCurrentBackupset] == 2)
			$fileSyncCount++;
	}
	$failedfiles_count = $j;
}

#************************************************************************************************************************
# Subroutine Name       : updateFailedFileCount
# Objective             : This subroutine gets the updated failed files count incase retry backup is in process  
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function updateFailedFileCount()
{
	GLOBAL $currentBackupset,$backup_error,$failedfiles_count;
	$orig_count = getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");
	if(strstr($backup_error,'failedfiles.txt')){
		$size_Backupset = count($currentBackupset);
		$newcount = $orig_count - $size_Backupset + $failedfiles_count;
		$failedfiles_count = $newcount;
	}else{
		$orig_count += $failedfiles_count;
		$failedfiles_count = $orig_count;
	}
}

#***********************************************************************************************************************
# Subroutine Name       : jobTerminate
# Objective             : This subroutine terminates the job in case of error
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#************************************************************************************************************************
function jobTerminate($reason)
{
	GLOBAL $phpPath,$fileJobTerminationPath,$exit_flag;
	$errStr = "Operation could not be completed. Reason :".$reason;
	//`$phpPath $fileJobTerminationPath`;
	$cmd = "$phpPath $fileJobTerminationPath";
	`$cmd`;	
	$exit_flag = "1-$errStr";
}

#*************************************************************************************************************************
# Subroutine Name       : insert
# Objective             : This subroutine inserts entry to DB 
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function insert($retry, $fileName, $fileLMD, $fileSize, $levelCount)
{
	GLOBAL $dbh_insert;
	
	$fileDetail = array($fileName, $fileLMD, $fileSize, $levelCount);
	try{
		$rows = $dbh_insert->execute($fileDetail);
	} catch(PDOException $e) {
		traceLog("FasterSync: Insert failed for file: $fileName. Reason:".$e->getMessage());
		if($retry == TRY_UPDATE){
			update(0, $fileLMD, $fileSize, time(), $levelCount, $fileName);
		}			
	}		
}

#************************************************************************************************************************
# Subroutine Name       : update
# Objective             : This subroutine updates DB entry   
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function update($retry, $fileLMD, $fileSize, $time, $levelCount, $fileName)
{
	GLOBAL $dbh_update;	

	$fileDetail = array($fileLMD, $fileSize, $time, $levelCount, $fileName);
	try{
		$rows = $dbh_update->execute($fileDetail);
	} catch(PDOException $e) {
		traceLog("FasterSync: Update failed for file: $fileName. Reason:".$e->getMessage());
		if($retry == TRY_INSERT){
			insert(0, $fileName, $fileLMD, $fileSize, $levelCount);			
		}			
	}	
}

#************************************************************************************************************************
# Subroutine Name       : insertIbFile
# Objective             : This subroutine inserts entry to IbFile
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function insertIbFile($retry,$dirID,$fileName,$modtime,$fieldSize,$bksetLMD,$syncDate,$bksetName,$hashValue,$fieldFolderId,$fieldMPC,$fieldEncName,$fileOrFolder,$backupStatus)
{
	GLOBAL $dbh_ibFile_insert;
	$fileDetail = array($dirID,$fileName,$modtime,$fieldSize,$bksetLMD,$syncDate,$bksetName,$hashValue,$fieldFolderId,$fieldMPC,$fieldEncName,$fileOrFolder,$backupStatus);

	try{
		$rows = $dbh_ibFile_insert->execute($fileDetail);
	} catch(PDOException $e) {
		traceLog("Insert entry to IbFile table has failed for file: $fileName. Reason:".$e->getMessage());
		if($retry == TRY_UPDATE){
			updateIbFile(0, $modtime, $fieldSize, $fileName, $fieldFolderId, $dirID, $fieldMPC, $fieldEncName);	
		}			
	}	
}

#************************************************************************************************************************
# Subroutine Name       : insertIbFolder
# Objective             : This subroutine inserts entry to IbFolder
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function insertIbFolder($retry, $fileName, $modtime, $fieldSize )
{
	GLOBAL $dbh_ibFolder_insert;
	
	$fileDetail = array($fileName,$modtime,$fieldSize,"NA");
	try{
		$rows = $dbh_ibFolder_insert->execute($fileDetail);
	} catch(PDOException $e) {
		traceLog("Insert entry to IbFolder table has failed for file: $fileName. Reason:".$e->getMessage());
		if($retry == TRY_UPDATE){
			updateIbFolder(0, $modtime, $fileName);
		}			
	}		
}

#************************************************************************************************************************
# Subroutine Name       : updateIbFile
# Objective             : This subroutine updates entry to IbFile
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function updateIbFile($retry, $modtime, $fieldSize, $fileName, $fieldFolderId, $dirID, $fieldMPC, $fieldEncName)
{	
	GLOBAL $dbh_ibFile_update;
	
	$fileDetail = array($modtime,$fieldSize,$fileName,$fieldFolderId);
	try{
		$rows = $dbh_ibFile_update->execute($fileDetail);
	} catch(PDOException $e) {
		traceLog("Update entry to IbFile table has failed for file: $fileName. Reason:".$e->getMessage());
		if($retry == TRY_INSERT){
			insertIbFile(0, $dirID, $fileName, $modtime, $fieldSize, 'NA', 'NA', "Default Backupset", '0', $fieldFolderId, $fieldMPC, $fieldEncName, '1', '1');
		}			
	}
}

#************************************************************************************************************************
# Subroutine Name       : updateIbFolder
# Objective             : This subroutine updates entry to IbFolder
# Added By              : Senthil Pandian [12/01/2016]
# Modified By			: 
#*************************************************************************************************************************
function updateIbFolder($retry, $modtime, $fileName)
{
	GLOBAL $dbh_ibFolder_update;
	
	$fileDetail = array($modtime,$fileName);
	try{
		$rows = $dbh_ibFolder_update->execute($fileDetail);
	} catch(PDOException $e) {
		traceLog("Update entry to IbFolder table has failed for file: $fileName. Reason:".$e->getMessage());
		if($retry == TRY_INSERT){
			insertIbFolder(0, $fileName, $modtime, '0');
		}			
	}
}
