<?php
include('fetchPath.php');
define('LOCALSEARCHPATH',"\/Backup\/\.\+searchList");
define('REMOTESEARCHPATH',"\/Restore\/\.\+searchList");
define('TRASHSEARCHPATH',"\/Restore\/\.\+trashList");
$operationType = 0;
$jobStatusCmd = "";
$arg = "";

if(isset($argv[1]))
	$arg = $argv[1]; 

$jobName = `pwd`;
$jobName = trim($jobName);
getOperationType($jobName);
$pidPath = $jobName.PATHSEPARATOR.PIDFILE;
$jobTermPath = $jobName.PATHSEPARATOR.UTFFILE;
$processKilled = 0;

if(!file_exists($pidPath)) {
	traceLog("$jobName is not running");
	return;
}

constructJobTerminateCommand();

if($jobStatusCmd == ""){
	@unlink($pidPath);	
	@unlink($jobTermPath);
}
else{
	$psResult = `$jobStatusCmd`;
	$arr = preg_split('/\n/', $psResult);
	$len = count($arr);
	createUserCancel();
	@unlink($pidPath);
	@unlink($jobTermPath);

	for($i = 0; $i < $len; $i++) {
		$arr[$i] = trim($arr[$i]);
		if(preg_match("/grep/",$arr[$i]))
			continue;
		
		$tmpArr = explode($separator, $arr[$i]);
		for($j = $pidIdx; $j < count($tmpArr) ; $j++){
			if($tmpArr[$j] != "" and preg_match('/^\d+$/', $tmpArr[$j])){
				`kill -9 $tmpArr[$j]`;
				$processKilled = 1;
				break;
			}     
		}
	}
	
	if($processKilled)
		traceLog("$jobName has been killed");
	else
		traceLog("Not able to kill $jobName.");
}

removeCutoffCronEntry();

#****************************************************************************************************
# Subroutine Name         : getOperationType.
# Objective               : Get operation type based on job path.
# Added By                : Avinash Kumar
#*****************************************************************************************************/
function getOperationType($jobPath)
{
	GLOBAL $localSearch, $remoteSearch, $trashSearch, $backup, $restore, $delete, $archive, $operationType;
	if(preg_match("/".LOCALSEARCHPATH."/", $jobPath))
		$operationType = LOCALSEARCH;
	elseif(preg_match("/".REMOTESEARCHPATH."/", $jobPath))
		$operationType = REMOTESEARCH;
	elseif(preg_match("/".TRASHSEARCHPATH."/", $jobPath))
		$operationType = TRASHSEARCH;		
	elseif(preg_match("/".BACKUP."/", $jobPath))
		$operationType = BACKUP;
	elseif(preg_match("/".RESTORE."/", $jobPath))
		$operationType = RESTORE;
	elseif(preg_match("/".DELETE."/", $jobPath))
		$operationType = DELETE;
	elseif(preg_match("/".ARCHIVE."/", $jobPath))
		$operationType = ARCHIVE;		
}

#****************************************************************************************************
# Subroutine Name         : createUserCancel.
# Objective               : Generate cancel.txt for backup and restore operations
# Added By                : Avinash Kumar
#*****************************************************************************************************/
function createUserCancel()
{
	GLOBAL $operationType, $arg;
	if(BACKUP != $operationType and RESTORE != $operationType)
		return;
	
	if(!($CFH = fopen(CANCEL_PATH, "a"))){
		traceLog("Could not open file ".CANCEL_PATH.", Reason:$!");
		return;
	}
	
	if("" != $arg)
		fwrite($CFH, 'Operation could not be completed. Reason : Operation Cancelled due to Cut off.');
	else 
		fwrite($CFH, 'Operation could not be completed, Reason: Operation Cancelled by User.');
	
	fclose($CFH);
	@chmod(CANCEL_PATH,PERMISSIONVAL);
}

#****************************************************************************************************
# Subroutine Name         : removeCutoffCronEntry.
# Objective               : remove cut off entry from crontab
# Added By                : Pooja H
#*****************************************************************************************************/
function removeCutoffCronEntry()
{
	GLOBAL $arg, $webDir, $userDir, $phpPath, $jobName;

	#In case of Job_termination for Start immediately option, cron entry for cut off will be removed
	if($arg != "" and $arg == 0){
		$temp_file = $userDir.PATHSEPARATOR.TEMP_OPERATION_FILE;
		if($TEMP_FILE = fopen($temp_file, "w")){
			fwrite($TEMP_FILE, "removeCrontabEntry\n");
			fwrite($TEMP_FILE, "\"$jobName\"");
			fclose($TEMP_FILE);
			
			$operationsFile = $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR.SCRIPTS.PATHSEPARATOR.OPERATIONSFILE; 
			exec("$phpPath $operationsFile");
			traceLog("Could not execute ".OPERATIONSFILE);
		}
		else 
			traceLog("Could not open file $temp_file.Reason : ".customErrorMsg());
	}
}

#****************************************************************************************************
# Subroutine Name         : constructJobTerminateCommand.
# Objective               : To get the job termination command depending on the job type.
# Added By                : Pooja H
#*****************************************************************************************************/
function constructJobTerminateCommand()
{
	GLOBAL $operationType, $jobTermPath, $jobName, $jobStatusCmd;
	$jobtype = "";
	if(BACKUP == $operationType or RESTORE == $operationType or REMOTESEARCH == $operationType or ARCHIVE == $operationType or TRASHSEARCH == $operationType){
		$jobtype = "BACKUP_RESTORE_REMOTESEARCH_CLEANUP";
		$jobTermPath = str_replace("'","'\\''",$jobTermPath); 
		$jobTermPath = "'".$jobTermPath."'";
		$jobStatusCmd = getJobTerminationCommand($jobTermPath, $jobtype);
	}
	elseif(LOCALSEARCH == $operationType){
		$jobtype = "LOCALSEARCH";
		$jobName = str_replace("'","'\\''",$jobName); 
		$jobName = "'".$jobName."'";
		$jobStatusCmd = getJobTerminationCommand($jobName, $jobtype);
	}
	elseif(DELETE == $operationType){
		$jobtype = "DELETE";
		$jobStatusCmd = getJobTerminationCommand($jobName, $jobtype);
	}
}
?>
