<?php
GLOBAL $currentFilePath;
require('sqliteDB.php');

$operationComplete 				= "100%";
$jobType 						= "Restore_";
$lineCount 						= 0;
$currentRestoreset 				= array();
$prevLineCount 					= 0;
$sleep_count 					= 0;
$retryRestoreCancel 			= 0;
$jobrunningDir 					= `pwd`;
$jobrunningDir 					= trim($jobrunningDir);
$failedfiles_array 				= array();
$failedfiles_array_Encrypted 	= array();
$fileRestoreCount 				= 0;
$fileSyncCount 					= 0;
$failedfiles_count 				= 0;
$current_RestoresetHash 		= array();
$estoresetHashOrig_Encrypted 	= array();
	
#Indicates whether the script should retry the backup operation         
$retryAttempt 					= false;

# parameters sent with the script calling
$logOutputFilePath 				= $argv[1];							   
$current_restoresetfile 		= $argv[2];
$relative 						= $argv[3];
$current_source 				= $argv[4];
$filesonly 						= $argv[5];
$opStartTimeRestore 			= $argv[6];
$failedfiles_index 				= 0;
$restore_error 					= $current_restoresetfile."_ERROR";

#Errors encountered during restore operation for which the script should retry the restore operation                          
$ErrorArgumentsRetry 			= array(
									   "io timeout",
									   "Operation timed out",
									   "nodename nor servname provided, or not known",
									   "failed to connect",
									   "Connection refused",
									   "unauthorized user"
									  );

#Errors encountered during restore operation for which the script should not retry the restore operation                          
$ErrorArgumentsNoRetry 			= array(
										"failed: No such file or directory",
										"File name too long",
										"SFERROR",
										"IOERROR",
										"mkstemp",
										"encryption verification failed",
										"some files could not be transferred due to quota over limit",
										"account is under maintenance",
										"account has been cancelled",
										"account has been expired",
										"protocol version mismatch",
										"password mismatch",
										"out of memory",
										"failed verification -- update"
										);

# Errors encountered during restore operation for which the script should not retry the restore operation                         
$ErrorArgumentsExit 			= array(
										"encryption verification failed",
										"some files could not be transferred due to quota over limit",
										"skipped-over limit",
										"account is under maintenance",
										"account has been cancelled",
										"account has been expired",
										"protocol version mismatch",
										"password mismatch",
										"No route to host",
        					            "bad response from proxy",
										"invalid source path for operation",
										"out of memory",
										"failed to get the device information"
										);

$statusFileHash 				= array();
#Checking whether current job is offline/online.
$jobDir 						= $jobrunningDir."/";
$skip 							= 0;

if( extension_loaded('pcntl') && function_exists('pcntl_signal') ){
	declare(ticks = 1); //To handle signals (Kill/Term/..etc)
	pcntl_signal(SIGINT, 'process_term');
	pcntl_signal(SIGTERM, 'process_term');
}
#Checking whether current job is local or online
if($isLocalRestore == 1){
	loadToHashLocal($current_restoresetfile);
}
else
{
	loadToHash($current_restoresetfile);
}							

subOutputProcess();
subErrorRoutine();
writeParameterValuesToStatusFile();

#****************************************************************************************************
# Subroutine Name         : loadToHashLocal.
# Objective               : This function creates a hash of RestoreSet items incase of Local Restore
# Added By				  : Vijay Vinoth
#*****************************************************************************************************/
function loadToHashLocal($current_restoresetfile)
{
	GLOBAL $current_RestoresetHash,	$RestoresetHashOrig_Encrypted,	$currentRestoreset;
	
	$origRestoresetFile 		= $current_restoresetfile."_org";	
	$currentRestoresetEncrypted = file($current_restoresetfile);
	$currentRestoreset 			= file($origRestoresetFile);
	
	if(empty($currentRestoresetEncrypted))
	{
		traceLog("Unable to open current restore file $currentRestoresetEncrypted, Reason:".customErrorMsg());
		exit;
	}
	if(empty($currentRestoreset))
	{
		traceLog("Unable to open current restore file $currentRestoreset, Reason:".customErrorMsg());
		exit;
	}
	
	# only one file will be there for version restore
	$currentRestoreset[0] 		= preg_replace('/_IBVER+\d$/', '', $currentRestoreset[0]);
	
	$currentRestoresetCount 	= count($currentRestoreset);
	for ($i=0; $i < $currentRestoresetCount; $i++)
	{
		$currentRestoresetValue = trim($currentRestoreset[$i]);
		$current_RestoresetHash[$currentRestoresetValue] = 0;
		$RestoresetHashOrig_Encrypted[$currentRestoresetValue] = trim($currentRestoresetEncrypted[$i]);
	}		
}		

#****************************************************************************************************
# Subroutine Name         : loadToHash.
# Objective               : This function manage the hash for failed file check.
# Added By				  : Vijay Vinoth
#*****************************************************************************************************/
function loadToHash($current_restoresetfile)
{
	GLOBAL $current_RestoresetHash,	$currentRestoreset;

	$currentRestoreset = file($current_restoresetfile);	
	if(empty($currentRestoreset))
	{
		traceLog("Unable to open current restore file $current_restoresetfile, Reason:".customErrorMsg());
		exit;
	}

	$current_restoresetfile_size = customFileSize($current_restoresetfile);
	if($current_restoresetfile_size>0)
	{
		# only one file will be there for version restore
		$currentRestoreset[0] = preg_replace('/_IBVER+\d$/', '', $currentRestoreset[0]);
		$currentRestoresetCount = count($currentRestoreset);
		
		for ($i=0; $i < $currentRestoresetCount; $i++)
		{
			if($currentRestoreset[$i] == ""){
				continue;
			}
			$current_RestoresetHash[trim($currentRestoreset[$i])] = 0;
		}		
	}
}

#****************************************************************************************************
# Subroutine Name         : subOutputProcess.
# Objective               : This function monitors and parse the evs output file and creates the App 
#							log file which is shown to user. 					
# Modified By             : Deepak Chaurasia, Vijay Vinoth.
#*****************************************************************************************************/                                      
function subOutputProcess()
{
	GLOBAL $logOutputFilePath,	$operationComplete;
	GLOBAL $opStartTimeRestore, $filesonly;
	GLOBAL $isLocalRestore,		$skip,					$restore_error;
	GLOBAL $current_RestoresetHash;
	
	$Restoretype = "";
	# Flags to determine the status of OUTFILE 
	$fileOpened 		= 0;
	$termData 			= "CHILD_PROCESS_COMPLETED";
	
	$fields_in_progress = 10;	
	$byteRead 			= 0;
	$lastLine  			= "";
	# Waiting for EVS output file to open
	while(!$fileOpened)
	{
		if(!file_exists(PIDFILE))
			break;
		
		if(file_exists(OUTPUTFILE)){
			if($tempOutputFile = fopen(OUTPUTFILE,'r')){
				$fileOpened = 1;
			} else {
				traceLog("Could not open file : ".OUTPUTFILE.", Reason : ".customErrorMsg());
				break;
			}
		}
		sleep(2);
	}
	
	# As while is an indefinite loop for now so this condition will not make any sense but we may use it later
	if($fileOpened == 0)
	{
		traceLog("Unable to open file ".OUTPUTFILE);
		return;
	}

	# App log file open for parsed output
	$logOutputHandle = fopen($logOutputFilePath,"a");
	if(!$logOutputHandle)
	{
		traceLog("Unable to open file $logOutputFilePath, Reason:".customErrorMsg());		
		fclose($tempOutputFile);				
		fclose($logOutputHandle);
		chmod($logOutputFilePath,PERMISSIONVAL);
		return;
	}
	$prevTransferedSize = 0;
	$totalTransfered 	= 0;
	if(file_exists(PROGRESS_PATH) && customFileSize(PROGRESS_PATH))
	{
		$progressContent = file_get_contents(PROGRESS_PATH);	
		$progressContent = explode("\n",$progressContent);
		$totalTransfered = isset($progressContent[3])?$progressContent[3]:'';	
	}
	
	while (1)
	{
		$buffer 	= fread($tempOutputFile, LIMIT);
		$byteRead 	= strlen($buffer);		
		if($byteRead === 0)
		{
			if(!file_exists(PIDFILE))
				break;
			
			sleep(2);
			fseek($tempOutputFile, 0, 1);		#to clear eof flag
			continue;
		}
		
		//need to check appending partial record to packet or to first line of packet
		if("" != $lastLine){
			$buffer = $lastLine.$buffer;
		}
		
		if(!preg_match('/\n$/', $buffer)){
			$lastNewlinePos = strrpos($buffer, "\n");
			$resultList = substr($buffer,0,$lastNewlinePos);
			$lastLine   = substr($buffer,$lastNewlinePos);
		} else {
			$resultList = $buffer;
			$lastLine = '';
		}
		
		$noOfLines  = substr_count($resultList,"\n");
		$resultListXML = "<root>$resultList</root>";
		$xml = simplexml_load_string($resultListXML);
		
		if(!$xml){
			$resultListXML = checkAndConstructXML($resultList);
			$resultListXML = "<root>$resultListXML</root>";
			$xml = simplexml_load_string($resultListXML);
		}
		
		$toCheck = 0;
		foreach ($xml->item as $value)
		{
			$filename		= trim($value['fname']);
			$trf_type		= trim($value['trf_type']);
			$size			= trim($value['size']);
			$tottrf_sz		= trim($value['tottrf_sz']);
			$rate_trf		= trim($value['rate_trf']);
			$per			= trim($value['per']);
			
			replaceXMLcharacters($filename,RESTORE);
			if($tottrf_sz == 0 && $trf_type == "FILE IN SYNC"){
				$totalTransfered 	+= $size;
				$prevTransferedSize = 0;
			}
			else{
				$totalTransfered 	+= $tottrf_sz - $prevTransferedSize;
				$prevTransferedSize = $tottrf_sz;
			}
		
			updateProgressFile($trf_type, $filename, $size, $totalTransfered, $rate_trf, $opStartTimeRestore);

			if($per == $operationComplete ){
				$Restoretype = "";
				$keyString = $filename;
				
				if($isLocalRestore != 1)
					$keyString = PATHSEPARATOR.$keyString;
				
				# check if file in sync
				if($trf_type == "FILE IN SYNC") 		
					$Restoretype = "Sync Restore";
				else if($trf_type == "FULL")
					$Restoretype = "Full Restore";
				else if($trf_type == "INCREMENTAL")
					$Restoretype = "Incremental Restore";

				if($Restoretype != "")
				{
					if(isset($current_RestoresetHash[$keyString])){
						if($Restoretype == "Sync Restore")
							$current_RestoresetHash[$keyString] = 2;
						else
							$current_RestoresetHash[$keyString] = 1;
					}
					else
						getFullPathofFile($keyString, $Restoretype);
					
					if($Restoretype != "Sync Restore"){
						$restoreFinishTime 	= trim(shell_exec('date +"%a %b %d %T %Y"'));
						$fileSize 			= convertFileSize($size); 
						
						if($filesonly == 1 && strrpos($filename, "/") >1)
							$filename = substr($filename,strrpos($filename, "/")+1);
						
						#log this message to App logs
						if($isLocalRestore != 1)
							$filename = PATHSEPARATOR.$filename;

						fwrite($logOutputHandle,"[$restoreFinishTime] [$Restoretype] [SUCCESS] [$filename] [$fileSize] ".LINEFEED);
					}
				}
			}
			$toCheck++;
		}
		
		if(strstr($resultList,$termData)) {
			@unlink(OUTPUTFILE);
			$skip = 1;
			break;
		}  
		else if($noOfLines > $toCheck){
			$exp  = explode("\n",$resultList);
			foreach($exp as $data){
				$data = trim($data);
				if(!empty($data) && strpos($data,"<item")===false && strpos($data,"size=")===false && strpos($data,'receiving file list') === false && strpos($data,'connection established') === false && strpos($data,'bytes  received') === false)
					addtionalErrorInfo($data,$restore_error);
			}
		}
		
		if($skip == 1){
			$skip = 0;
			break;
		}				
    }
	fclose($tempOutputFile);				
	fclose($logOutputHandle);
	chmod($logOutputFilePath,PERMISSIONVAL);
}

#****************************************************************************************************
# Subroutine Name         : subErrorRoutine.
# Objective               : This subroutine checks if the temporary error file is present.
#							If present, it scans the temporary error file.In case the account is under maintenance / has expired /	
#							has been canceled, it exits the restore operation
#							Also file names are added to the hash representing error in file restore in case 
#							errors are encountered while restore is in progress
#							Also the subroutine checks for errors for which it should retry the restore operation
#							
# Modified By             : Vijay Vinoth.
#*****************************************************************************************************/   
function subErrorRoutine()
{
	GLOBAL $restore_error,	$jobrunningDir,	$retryAttempt;
	GLOBAL $failedfiles_array, $isLocalRestore;
	GLOBAL $relative, $current_source, $failedfiles_array_Encrypted;
	
	# get restore failed file count.
	getFailedFileCount();	
	$failedfiles 				= "";
	$individual_errorfile_size	= 0;
	
	#Copying evs generated error.txt to RESTORE_ERRORFILE
	copyTempErrorFile($restore_error);	
	unlink(ERRORFILE);
	
	$failedfiles_index 		= getParameterValueFromStatusFile("FILE_COUNT_INDEX");
	$individual_errorfile 	= $jobrunningDir."/".ERROR_DIR."/$restore_error";
	
	if(file_exists($individual_errorfile))
		$individual_errorfile_size = customFileSize($individual_errorfile);

	if($individual_errorfile_size > 0 && $failedfiles_index != -1){
		if(!checkretryAttempt($individual_errorfile)){
			getFinalErrorFile();
			updateFailedFileCount();
			return;
		}
	}
	else {
		getFinalErrorFile();
		updateFailedFileCount();
		return;
	}
	
	if(!$retryAttempt || $failedfiles_index == -1)
		getFinalErrorFile();
	else 
	{
		$failedfiles_index 			= getParameterValueFromStatusFile("FILE_COUNT_INDEX");
		$failedfiles_array_count 	= count($failedfiles_array);
		if($failedfiles_array_count > 0)
		{	
			$failedfiles_index++;
			$failedfiles 	= TEMP_FILES."/failedfiles.txt".$failedfiles_index;
			$oldfile_error 	= $jobrunningDir."/".ERROR_DIR."/$restore_error";
			$newfile_error 	= $jobrunningDir."/".ERROR_DIR."/$failedfiles"."_ERROR";
			
			if(file_exists($oldfile_error) || file_exists($oldfile_error."_FINAL"))
				rename($oldfile_error, $newfile_error);
			
			if($isLocalRestore == 1){
				$failedfileOrig = $failedfiles."_org";
				$FD 			= fopen($failedfileOrig, 'w');	
				
				if(!$FD){
					traceLog("Unable to open file $failedfileOrig, Reason:".customErrorMsg());	
					updateFailedFileCount();					
					return;
				}				
				$arrayContent 		= join("\n", $failedfiles_array);
				fwrite($FD,"$arrayContent\n");
				fclose($FD);
				$failedfiles_array 	= array();
				$failedfiles_array 	= $failedfiles_array_Encrypted;
			}
			
			$FAILEDLIST = fopen($failedfiles, 'w');		
			if(!$FAILEDLIST){
				traceLog("Unable to open file $failedfiles, Reason:".customErrorMsg());
				updateFailedFileCount();
				return;
			}
			$arrayContent = join("\n", $failedfiles_array);
			fwrite($FAILEDLIST,"$arrayContent\n");
			fclose($FAILEDLIST);
		}
	}
		
	if(file_exists($failedfiles))
	{
		$RETRYINFO = fopen(RETRY_INFOFILE, 'a');		
		if(!$RETRYINFO){
			traceLog("Unable to open file ".RETRY_INFOFILE.", Reason:".customErrorMsg());
			updateFailedFileCount();
			return;
		}
		fwrite($RETRYINFO,"$failedfiles $relative $current_source\n");
		fclose($RETRYINFO);
	}
	updateFailedFileCount();
}

#****************************************************************************************************
# Subroutine Name         : writeParameterValuesToStatusFile
# Objective               : This subroutine writes the value of the specified parameter to the Status File 
# Modified By             : Vijay Vinoth
#*****************************************************************************************************/
function writeParameterValuesToStatusFile()
{
	GLOBAL $fileRestoreCount,	$fileSyncCount;
	GLOBAL $failedfiles_count,	$failedfiles_index,	$retryRestoreCancel, $statusFileHash;

	$Restorecount	=	$Synccount	=	$failedcount = 0;		
	$Restorecount 	= getParameterValueFromStatusFile("RESTORE_COUNT_FILES_INDEX");
	$Synccount 		= getParameterValueFromStatusFile("SYNC_COUNT_FILES_INDEX");
	$failedcount 	= getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");	
	$statusFile 	= fopen(STATUSFILE, 'w');	
	if(!$statusFile){
		traceLog("Unable to open file ".STATUSFILE.", Reason:".customErrorMsg());
		return;
	}	

    # Calculate the restore, sync and error count based on new values
	$Restorecount 	+= $fileRestoreCount;
	$Synccount 		+= $fileSyncCount;
	$failedcount 	= $failedfiles_count;	
	$input_data 	= "RESTORE_COUNT_FILES_INDEX = $Restorecount \n";
	$input_data 	.= "SYNC_COUNT_FILES_INDEX = $Synccount \n";
	$input_data 	.= "FAILED_COUNT_FILES_INDEX = $failedcount \n";
	$input_data 	.= "FILE_COUNT_INDEX = $failedfiles_index \n";
	$input_data 	.= "RESTORE_TERMINATION_INDEX = $retryRestoreCancel";
	
	fwrite($statusFile,$input_data);
	fclose($statusFile);
	chmod(STATUSFILE,PERMISSIONVAL);
	$statusFileHash = array();	
}

#****************************************************************************************************
# Subroutine Name         : getFailedFileCount.
# Objective               : This function calculate failed file count by checking current restore
#							hash value zero for failed file.              
# Added By				  : Vijay Vinoth
#*****************************************************************************************************/
function getFailedFileCount()
{
	GLOBAL $currentRestoreset,	$failedfiles_array,				$failedfiles_count,				$current_RestoresetHash;
	GLOBAL $isLocalRestore,		$failedfiles_array_Encrypted,	$RestoresetHashOrig_Encrypted,	$fileRestoreCount;
	GLOBAL $fileSyncCount;
	
	$currentRestoresetCount = count($currentRestoreset);
	$j = 0;
	
	for($i = 0; $i < $currentRestoresetCount; $i++){
		$tempCurrentRestoreset = trim($currentRestoreset[$i]);
		if(empty($tempCurrentRestoreset))
			continue;
		
		if($current_RestoresetHash[$tempCurrentRestoreset] == 0){
			$failedfiles_array[$j] = $tempCurrentRestoreset;
			if($isLocalRestore == 1)
				$failedfiles_array_Encrypted[$j] = $RestoresetHashOrig_Encrypted[trim($currentRestoreset[$i])];
			$j++;
		}
		elseif($current_RestoresetHash[$tempCurrentRestoreset] == 1)
			$fileRestoreCount++;
		elseif($current_RestoresetHash[$tempCurrentRestoreset] == 2)
			$fileSyncCount++;
	}
	$failedfiles_count = $j;
}

#****************************************************************************************************************************
# Subroutine Name       : getFullPathofFile
# Objective             : This subroutine gets the full path of files that have backed up 
# Added By              : Vijay Vinoth
#******************************************************************************************************************************/
function getFullPathofFile($fileToCheck, $type)
{
	GLOBAL $currentRestoreset,	$current_RestoresetHash;
	$retStr = trim($fileToCheck);
						
	for($i = count($currentRestoreset)-1; $i >= 0; $i--)
	{
		$currentRestoreset[$i]	= trim($currentRestoreset[$i]);
		if(strrpos($retStr, '/') == 0)
			$currentRestoresetTemp 	= strrpos($currentRestoreset[$i], '/');
		else
			$currentRestoresetTemp  = strpos($currentRestoreset[$i], '/');
		$match 					= substr($currentRestoreset[$i],$currentRestoresetTemp);
	
		if($retStr == trim($match))
		{
			if($type == "Sync Restore")
				$current_RestoresetHash[$currentRestoreset[$i]] = 2;
			else 
				$current_RestoresetHash[$currentRestoreset[$i]] = 1;
			
			break;
		}
	}
}

#****************************************************************************************************
# Subroutine Name         : checkretryAttempt.
# Objective               : This function checks whether restore has to retry              
# Added By				  : Vijay Vinoth
#*****************************************************************************************************/
function checkretryAttempt($individual_errorfile)
{
	GLOBAL $ErrorArgumentsExit,	$ErrorArgumentsRetry,	$retryAttempt, $phpPath;
	GLOBAL $webDir, $retryRestoreCancel, $dedupDetailFile, $dedupRestoreDeviceID;
	
	$errorline = "idevs error";
	
	#check for retry attempt
	if(!$handle = fopen($individual_errorfile,'r'))
	{
		//traceLog("Unable to open file $individual_errorfile");
		return 0;
	}
	$content 				= fread($handle, customFileSize($individual_errorfile));
	$linesRestoreErrorFile 	= explode("\n",$content);
	fclose($handle);
	
	#To check the individual error file for exit scenarios
	for($i = 0; $i< count($linesRestoreErrorFile); $i++)
	{		
		$tempLinesRestoreErrorFile = trim($linesRestoreErrorFile[$i]);		
		if($tempLinesRestoreErrorFile == "" || strstr($tempLinesRestoreErrorFile,$errorline))
		{
			continue;
		}
		
		for($j=0; $j< count($ErrorArgumentsExit); $j++)
		{
			if(strstr($tempLinesRestoreErrorFile,$ErrorArgumentsExit[$j]))
			{
				@unlink(OUTPUTFILE);
				
				if(file_exists(EVS_TEMP))
					exec("rm -rf ".EVS_TEMP);
				
				$errStr = "Operation could not be completed. Reason : $ErrorArgumentsExit[$j] \n";
				
				#kill evs and then exit
				$fileJobTerminationPath = $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR.SCRIPTS.PATHSEPARATOR.JOBTERMINATIONFILE;
				$cmd = "$phpPath $fileJobTerminationPath";
				`$cmd`;
				$retryRestoreCancel = true . "-$errStr";
				return 0;
			}
		}	
	}
	
	#To check the individual error file for retry case
	for($i = 0; $i< count($linesRestoreErrorFile); $i++)
	{
		$tempLinesRestoreErrorFile = trim($linesRestoreErrorFile[$i]);
		
		if($tempLinesRestoreErrorFile == "" or strstr($tempLinesRestoreErrorFile,$errorline))
		{
			continue;
		}
		
		for($j=0; $j<count($ErrorArgumentsRetry); $j++)
		{
			if(strstr($tempLinesRestoreErrorFile,$ErrorArgumentsRetry[$j]))
			{
				$retryAttempt = true;
				break;
			}
		}	
		if($retryAttempt)
		{
			break;
		}
	}
	return 1;
}

#****************************************************************************************************
# Subroutine Name         : updateFailedFileCount.
# Objective               : This function manage the counts of failed files during retry case.            
# Added By				  : Vijay Vinoth
#*****************************************************************************************************/
function updateFailedFileCount()
{
	GLOBAL $currentRestoreset,	$failedfiles_count,	$restore_error;
	
	$orig_count = getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");
	if(strpos( $restore_error,"failedfiles.txt" ) !== false){
		$size_Restoreset 	= count($currentRestoreset);
		$newcount 			= ($orig_count - $size_Restoreset) + $failedfiles_count;
		$failedfiles_count 	= $newcount;
	}
	else{
		$orig_count 		+= $failedfiles_count;
		$failedfiles_count 	= $orig_count;
	}
}

#****************************************************************************************************************************
# Subroutine Name         : getFinalErrorFile
# Objective               : This subroutine creates a final ERROR file for each backupset, which has to be displayed in LOGS  
# Modified By             : Vijay Vinoth
#******************************************************************************************************************************/
function getFinalErrorFile()
{
	GLOBAL $jobrunningDir,		$restore_error,		$retryRestoreCancel;
	GLOBAL $failedfiles_count,	$failedfiles_array,	$RestoresetHashOrig_Encrypted,	$hostNameLB,$username;
	GLOBAL $current_source,		$isLocalRestore;
	
	$cancel 				= 0;
	$failedWithReason 		= 0;
	$fileOpenFlag 			= 1;
	$individual_errorfile 	= $jobrunningDir."/".ERROR_DIR."/$restore_error";
	
	if(!$retryRestoreCancel){
		if(!file_exists(PIDFILE))
			$cancel = 1;
	}
		
	if($failedfiles_count > 0){
		$ERROR_FINAL = fopen($individual_errorfile."_FINAL", 'w+');
		
		if(!$ERROR_FINAL)
			$fileOpenFlag = 0;
		
		if(!$fileOpenFlag){
			traceLog("Unable to open file $individual_errorfile"."_FINAL, Reason:".customErrorMsg());
			return;
		}
		else{
			if(!file_exists($individual_errorfile))
				$fileOpenFlag = 0;
			else
				$RESTORE_ERROR = file($individual_errorfile);
		
			if(!$fileOpenFlag){
				if($retryRestoreCancel or $cancel != 0)
					$failedfiles_count = $failedWithReason;
				if($cancel==1)
					traceLog("Unable to open $individual_errorfile.");
				return;
			}
		}
		
		sort($failedfiles_array);
		
		$j 						= 0; 
		$last_index 			= count($RESTORE_ERROR);
		$destPath 				= trim($hostNameLB."/$username$current_source");
		$failedfiles_arrayCount = count($failedfiles_array);
		
		for($i = 0; $i < $failedfiles_arrayCount; $i++){
			$matched = 0;
			#reset the initial and last limit for internal for loop for new item if required
			if($j > $last_index){
				$j 			= 0;
				$last_index = count($RESTORE_ERROR);
			}
			
			#fill the last matched index for later use
			$index = $j;
			if($isLocalRestore == 1)
				$failedfile = $destPath.$RestoresetHashOrig_Encrypted[$failedfiles_array[$i]];
			else
				$failedfile = substr($failedfiles_array[$i],1);
			
			#try to find a match between start and end point of error file
			for($j=0;$j < $last_index; $j++){
				if(!empty($RESTORE_ERROR[$j])){
					if(strpos( $RESTORE_ERROR[$j], $failedfile ))
					{
						$failedfile = phpQuoteMeta($failedfile);
						$Reason = preg_replace("/.*$failedfile.*:/","",$RESTORE_ERROR[$j]);
						//fwrite($ERROR_FINAL,"[".date("D M d H:i:s Y")."] [FAILED] [$failedfiles_array[$i]]. Reason: $Reason ".LINEFEED);
						fwrite($ERROR_FINAL,"[".trim(shell_exec('date +"%a %b %d %T %Y"'))."] [FAILED] [$failedfiles_array[$i]]. Reason: $Reason ".LINEFEED);
						
						$matched = 1;
						$failedWithReason++;						
						#got a match so resetting the last index 
						$last_index = count($RESTORE_ERROR);
						$j++;
						break;
					}
				}
				#if no match till last item and intial index is not zero try for remaining error file content
				if($j == $last_index && $index != 0)
				{
					$j 			= 0;
					$last_index = $index;
					$index 		= $j;
				}
			}
			
			if($matched == 0 and !$retryRestoreCancel and $cancel == 0)
				fwrite($ERROR_FINAL,"[".trim(shell_exec('date +"%a %b %d %T %Y"'))."] [FAILED] [$failedfiles_array[$i]] ".LINEFEED);
		}
		
		fclose($ERROR_FINAL);
	}
	
	if($retryRestoreCancel or $cancel != 0)
		$failedfiles_count = $failedWithReason;
	@unlink($individual_errorfile);
}

#****************************************************************************************************
# Subroutine Name         : process_term
# Objective               : The signal handler invoked when SIGTERM signal is received by the script       
# Added By                : Vijay Vinoth    
#*****************************************************************************************************/
function process_term()
{
	GLOBAL $tempOutputFile, $logOutputHandle, $logOutputFilePath;
	if($tempOutputFile)
		fclose($tempOutputFile);

	if($logOutputHandle)
		fclose($logOutputHandle);
	
	chmod($logOutputFilePath,PERMISSIONVAL);

	writeParameterValuesToStatusFile();
	exit;
}
?>
