<?php
ini_set('track_errors', 1);
$backupUtfFile = "";
$current_source = "";
$rel_Data = "";
$BackupFile = "";
$exit_flag = false;
$Backupfilecount = 0;
$relative = 0;
$filesOnlyFile_count = 0;
$exitStatus = 0;
$noRelIndex = 0;
$excludeParArray = "";
$quotemeta = "";
$source = "";
$pid = "";
$pid_generate = "";
$pid_OutputProcess = "";

$processName = "main";
$hidden = "Enabled";
$varManualTask = '\+ManualTask\/';
$outputFileName = "BACKUP";

$jobDir = $jobrunningDir.PATHSEPARATOR;
$excludeFullPath = $userDir.PATHSEPARATOR.EXCLUDE_FULLPATH;
$excludePartialPath = $userDir.PATHSEPARATOR.EXCLUDE_PARTIALPATH;
$ArchiveJobPath = $userDir.PATHSEPARATOR.ARCHIVE.PATHSEPARATOR;
$DeleteJobPath = $userDir.PATHSEPARATOR.DELETE.PATHSEPARATOR;
$BackupsetFile_relative = TEMP_FILES."/".BACKUPSETFILE_RELATIVE;
$BackupsetFile_norelative = TEMP_FILES."/".BACKUPSETFILE_NORELATIVE;
$BackupsetFile_filesOnly = TEMP_FILES."/".BACKUPSETFILE_ONLYFILES;
$fileOnlySetName = $BackupsetFile_filesOnly;
$fileJobTerminationPath = $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR.SCRIPTS.PATHSEPARATOR.JOBTERMINATIONFILE;

$operationStartTime = time();
$ErrorArgumentsExit = array("No route to host",
							"not enough free space on device",
							"Input/output error",
							"error in file write",
							"Device not configured",
							"failed to get the device information",
							"encryption verification failed"
						);

# Checking whether current job is ManualTask or Scheduled
if(! preg_match("/$varManualTask/", $jobDir))
	$taskType = SCHEDULED;

# Read backup location
if($isLocalBackup == 1)
	$backupLocation = $hostNameLB;
else
	$backupLocation = readBackupLocation();

#****************************************************************************************************
# Subroutine Name         : generateBackupsetFiles
# Objective               : Generating backupset file/files based on backup set content based on exclude 
#							and relative/no-relative and the required data is entered to info_file.
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
function generateBackupsetFiles()
{	
	GLOBAL $BackupsetFile, $BackupArray, $source, $errStr;
	GLOBAL $isLocalBackup, $hidden, $relative;
	GLOBAL $ERRORFAILEDFILE, $filehandle, $EXTN, $FD_WRITE, $BACK_FILE, $dbh;
	GLOBAL $BackupFile, $totalSize, $filesonlycount, $fileOnlySetName, $bacSync, $failedFilesCount;
	GLOBAL $Backupfilecount, $noRelIndex, $BackupsetFile_norelative, $filecount, $current_source,  $totalFiles, $processName;
	$backupArrayCount = 0;
	
	$totalSize = 0;
	$processName = "generate";
	$bacSync = 0;	
	$filesonlycount = 0;
	$retVal = 0;
	
	$BackupArrayInitial = array();
	$BackupArrayInitial = file(BACKUPSETFORDISPLAY);
	
	$BackupArray  = array();
	for($i = 0; $i < count($BackupArrayInitial); $i+=2){
		$BackupArrayInitial[$i] = trim($BackupArrayInitial[$i]);
		if(!empty($BackupArrayInitial[$i]))
			array_push($BackupArray,$BackupArrayInitial[$i]);
	}
	$backupArrayCount = count($BackupArray);
	
	if(!$isLocalBackup){
		if(!createDB()){
			$errStr = "Create DB failed.";
			traceLog($errStr);
			generateBackupsetCleanup($errStr);
			return;
		}

		if(!prepareSelectStmt()){
			$errStr = "Prepare select statement failed.";
			traceLog($errStr);
			generateBackupsetCleanup($errStr);
			return;
		}
	}
	//$localtime = date("D M d H:i:s Y");
	$localtime = trim(shell_exec('date +"%a %b %d %T %Y"'));
	
	$pos = 0;
	$i = 0;
	do{	
		if(!file_exists(PIDFILE))
			break;
		
		$item = $BackupArray[$i];
		if(is_link($item)){
			//traceLog("[".$localtime."] [EXCLUDED] [$item]. Reason: Not a regular file/folder.");
			$i++;
			continue;
		}
		
		if(($hidden == 'Disabled') && preg_match('/\/\./',$item)){
			$i++;			
			continue;
		}
		
		$printItem = getPrintItem($item);
		if(!file_exists($item)){
			fwrite($ERRORFAILEDFILE, "[".$localtime."] [FAILED] [$printItem] Reason: No such file or directory".LINEFEED);
			$failedFilesCount++;
			$totalFiles++;
			$i++;
			continue;
		}
		
		$ret = excludeCheck($item, $printItem);
		if($ret == 1){
			$i++;
			continue;
		}
		elseif($ret == 2){
			generateBackupsetCleanup("");
			return;
		}
		
		if(is_dir($item)){	
			if($relative == 0){
				$Backupfilecount = 0;
				$noRelIndex++;
				$BackupFile = $BackupsetFile_norelative."$noRelIndex";
				$filecount = 0;
				
				$pos = strrpos($item, "/");
				$source[$noRelIndex] = substr($item,0,$pos);
				if($source[$noRelIndex] == "")
					$source[$noRelIndex] = "/";
				$current_source = $source[$noRelIndex];
				
				if(!($filehandle = fopen($BackupFile,"w"))){
					$errStr = "Unable to open $BackupFile to write, Reason: $!";
					generateBackupsetCleanup($errStr);
					return;
				}
			}
		
			if(!$isLocalBackup){
				$retVal = getSearchResultfromDB($item, 0);
	
				if(!$retVal){
					$errStr = "Unable to open ExtendedBackupList file to write.";
					generateBackupsetCleanup($errStr);
					return;
				}
				elseif($retVal == 2){
					$i++;
					continue;
				}
			}
			
			if(!enumerate($item)){
				$errStr = "Enumerate failed for item : $item \n";
				generateBackupsetCleanup($errStr);
				return;
			}	
			
			if($relative == 0 && $filecount>0)
				fwrite($FD_WRITE, "$BackupFile ".RELATIVE." $current_source\n");
		}
		else{
			fwrite($BACK_FILE, $printItem.LINEFEED);
			$totalSize += customFileSize($item);
			$current_source = getSource();
			
			if($relative == 0){
				$filesonlycount++;
				$filecount = $filesonlycount;
			}
			else
				$filecount++;
			
			$totalFiles++;
			if($filecount == FILE_MAX_COUNT){
				$filesonlycount = 0;
				if(!createBackupSetFiles1k("FILESONLY")){
					$errStr = "\nCouldnot open new Backupsetfile for files only to write.";
					generateBackupsetCleanup($errStr);
					return;
				}
			}
		}
		$i++;
		
		if(!$isLocalBackup and ($backupArrayCount == BACKUPARRAY_LIMIT)){
			$BackupArray = array();		
			loadExtendedList();
			$i = 0;
			$backupArrayCount = count($BackupArray);
		}
	}while($i <= $backupArrayCount-1);
	
	# create totalsize.txt
	file_put_contents(TOTAL_SIZE_PATH, $totalSize);
	@chmod(TOTAL_SIZE_PATH, PERMISSIONVAL);
	
	if(!$isLocalBackup)
		readRemainingResultsFromDB();
	
	if($relative == 1 && $filecount == 0)
		@unlink($BackupFile);
	elseif($filesonlycount == 0)
		@unlink($fileOnlySetName);
	
	if($relative == 1 && $filecount > 0){
		$current_source = getSource();
		fwrite($FD_WRITE, "$BackupFile ".RELATIVE." $current_source \n");
	}
	elseif($filesonlycount > 0){
		$current_source = "/";
		fwrite($FD_WRITE, "$fileOnlySetName ".NORELATIVE." $current_source\n");
	}

	if(is_resource($EXTN))
		fclose($EXTN);
	
	generateBackupsetCleanup("");
}


#****************************************************************************************************
# Subroutine Name         : generateBackupsetCleanup
# Objective               : To complete the error cleanup and exit out of generateBackupset Function
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
function generateBackupsetCleanup($errStr = '')
{
	GLOBAL $FD_WRITE, $bacSync, $totalFiles, $failedFilesCount, $ERRORFAILEDFILE, $BACK_FILE, $dbh;
	
	fwrite($FD_WRITE, "BAC_SYNC $bacSync\n");
	fwrite($FD_WRITE, "TOTALFILES $totalFiles\n");
	fwrite($FD_WRITE, "FAILEDCOUNT $failedFilesCount");
	fclose($FD_WRITE);
	fclose($ERRORFAILEDFILE);
	
	if(is_resource($BACK_FILE))
		fclose($BACK_FILE);

	if("" != $errStr)
		writeBackupErrorMsgToStatusFile($errStr);
	
	# newly added if dbh is defined then only close.
	if($dbh)
		unset($dbh);
}

#**********************************************************************************************************
# Subroutine Name         : enumerate
# Objective               : This function recursively enumerates a directly and enters data in the created 
#							backupset files.  		
# Added By                : Pooja Havaldar
#**********************************************************************************************************/
function enumerate($item)
{	
	GLOBAL $failedFilesCount;
	GLOBAL $totalFiles, $filecount;
	GLOBAL $isLocalBackup;
	GLOBAL $backupLocation;
	GLOBAL $relative;
	GLOBAL $totalSize;
	GLOBAL $current_source;
	GLOBAL $hidden;
	GLOBAL $ERRORFAILEDFILE, $filehandle, $BACK_FILE;
	
	//$localtime = date("D M d H:i:s Y");
	$localtime = trim(shell_exec('date +"%a %b %d %T %Y"'));
	$retVal = 1;
	$errStr = "";
	if (substr($item, -1, 1) != "/")
		$item .= "/";
	
	# get path after 1st level
	$printItem = getPrintItem($item);
	
	if($DIR = opendir($item)) {
		while (($file = readdir($DIR)) !== false) {
			if(! file_exists(PIDFILE))
				break;
			
			if ($file == "." or $file == "..")
				continue;
						
			$temp = "";
			$temp = trim($item.$file);
			
			if(is_link($temp)){
				//traceLog("[".$localtime."] [EXCLUDED] [$temp]. Reason: Not a regular file/folder.");
				continue;
			}
			
			if(($hidden === 'Disabled') && preg_match("/\/\./", $temp))
				continue;
		
			if(!file_exists($temp)){
				fwrite($ERRORFAILEDFILE, "[".$localtime."] [FAILED] [$printItem$file] Reason :".customErrorMsg().LINEFEED);
				$failedFilesCount++;
				$totalFiles++;
				continue;
			}
			
			$ret = excludeCheck($temp, $printItem.$file);
			if($ret == 1)
				continue;
			elseif($ret == 2)
				return 0;
			
			if(is_dir($temp)){
				if(!enumerate($temp)){
					$errStr = "Enumerate failed for item : $temp \n";
					$retVal = 0;
					break;
				}		
			}
			else{
				$totalFiles++;
				if(!$isLocalBackup){
					if(checkForSync($backupLocation.$printItem.$file, $temp, 0))		#This subroutine checks for sync and remaining entries are written to PartialSyncFile
						continue;
				}

				if($relative == 0){
					$item_orig = $item;
					$totalSize += customFileSize($temp);
					if($current_source != "/"){
						$current_source_quote = preg_quote($current_source, '/');
						$item_orig = preg_replace("/$current_source_quote/","",$item_orig,1);
					}
					$temp = $item_orig.$file;
					fwrite($filehandle, "$temp".LINEFEED);
				}
				else{
					$current_source = getSource();
					fwrite($BACK_FILE, $printItem.$file.LINEFEED);
					$totalSize += customFileSize($temp);
				}
				
				$filecount++;	
				
				if($filecount == FILE_MAX_COUNT){
					if(!createBackupSetFiles1k("")){
						$errStr = "\nCouldnot open new Backupsetfile to write.";
						$retVal = 0;
						break;
					}
				}
			}
		}
		closedir($DIR);
	}
	else{
		$reason = customErrorMsg();
		$errStr = "Unable to open directory $item, Reason:$reason\n";
		if(strpos($reason,'Permission denied')>=0)
			fwrite($ERRORFAILEDFILE, "[".$localtime."] [FAILED] [$printItem] Reason : Permission denied.".LINEFEED);
		else
			fwrite($ERRORFAILEDFILE, "[".$localtime."] [FAILED] [$printItem] Reason : No such file or directory.".LINEFEED);
		$failedFilesCount++;
		$totalFiles++;
	}
	
	if("" != $errStr){
		traceLog($errStr);
		writeBackupErrorMsgToStatusFile($errStr);
	}
	
	return $retVal;	
}

#****************************************************************************************************
# Subroutine Name         : createBackupSetFiles1k.
# Objective               : Construct the backup set file/files based on relative or no-relative.
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
function createBackupSetFiles1k($filesOnly_flag)
{
	GLOBAL $Backupfilecount, $filecount;
	GLOBAL $relative, $fileOnlySetName, $current_source, $BackupsetFile_filesOnly ;
	GLOBAL $filesOnlyFile_count, $BackupFile, $noRelIndex, $BackupsetFile_norelative, $BackupsetFile_relative;
	GLOBAL $FD_WRITE, $BACK_FILE, $filehandle;
	
	$Backupfilecount++;
	if($relative == 0){
		if($filesOnly_flag == "FILESONLY"){
			$filesOnlyFile_count++;
			fwrite($FD_WRITE, "$fileOnlySetName ".NORELATIVE." $current_source\n");
			$fileOnlySetName = $BackupsetFile_filesOnly."_".$filesOnlyFile_count;
			fclose($BACK_FILE);
			if(!($BACK_FILE = fopen($fileOnlySetName,"w"))){
				traceLog("Unable to open $fileOnlySetName to write, Reason: ".customErrorMsg());
				return 0;
			}
		}
		else{
			fwrite($FD_WRITE, "$BackupFile ".RELATIVE." $current_source\n");
			$BackupFile = $BackupsetFile_norelative."$noRelIndex"."_$Backupfilecount";
			fclose($filehandle);
			if(!($filehandle = fopen($BackupFile,"w"))){
				traceLog("Unable to open file $BackupFile to write, Reason: ".customErrorMsg());
				return 0;
			}	
		}
	}
	else{
		fwrite($FD_WRITE, "$BackupFile ".RELATIVE." $current_source\n");
		$BackupFile = $BackupsetFile_relative."_$Backupfilecount";
		fclose($BACK_FILE);
		if(!($BACK_FILE = fopen($BackupFile,"w"))){
			traceLog("Unable to open file $BackupFile to write, Reason: ".customErrorMsg());
			return 0;
		}
	}

	$filecount = 0;
	return 1;
}

#**************************************************************************************************************************
# Subroutine Name         : getBackupOperationType.
# Objective               : This subroutine reads the .relative.txt to get the type of Backup Operation - mirror/relative
#							and also open the intermediate files required for backup based on mirror/relative
# Added By                : Pooja Havaldar
#**************************************************************************************************************************/
function getBackupOperationType()
{
	GLOBAL $isLocalBackup;
	GLOBAL $rel_Data;
	GLOBAL $relative;
	GLOBAL $current_source;
	GLOBAL $BackupFile;
	GLOBAL $BackupsetFile_relative;
	GLOBAL $BackupsetFile_filesOnly;
	GLOBAL $BACK_FILE;
	GLOBAL $userDir;
	
	# get the backup operation type mirror/relative
	if(($isLocalBackup == 1) or !file_exists("$userDir/".RELATIVE_FILEPATH)){	
		$rel_Data = RELATIVE;
		$relative = 1;
		$current_source = "/";
	}
	else{
		$rel_Data = file_get_contents("$userDir/".RELATIVE_FILEPATH);
		$rel_Data = trim($rel_Data);
		if($rel_Data === RELATIVE){
			$relative = 1;
			$current_source = "/";
		}
		else
			$relative = 0;
	}
		if(!is_dir(TEMP_FILES)){
			if(! mkdir(TEMP_FILES)){
				traceLog("Unable to create directory ".TEMP_FILES.", Reason:".customErrorMsg());
				unlink(PIDFILE);
				unlink(STARTPIDFILE);
				exit;
			}
			@chmod(TEMP_FILES, PERMISSIONVAL);
		}
	
	#opening the backup set files based on mirror/relative
	if($relative == 1){
		//traceLog("BackupsetFile_relative : $BackupsetFile_relative");
		if(!($BACK_FILE = fopen($BackupsetFile_relative,"w"))){
			traceLog("Unable to open file $BackupsetFile_relative to write, Reason: ".customErrorMsg());
			unlink(PIDFILE);
			unlink(STARTPIDFILE);
			exit;
		}
		$BackupFile =  $BackupsetFile_relative;
	}
	else {
		if(!($BACK_FILE = fopen($BackupsetFile_filesOnly,"w"))){
			traceLog("Unable to open file $BackupsetFile_filesOnly to write, Reason:".customErrorMsg());
			unlink(PIDFILE);
			unlink(STARTPIDFILE);
			exit;
		}
		$BackupFile =  $BackupsetFile_filesOnly;
	}
}

#******************************************************************************************************************
# Subroutine Name         : removeBackupTempFiles.
# Objective               : This subroutine romoves all temporary files and folders. Also cleanup condition based files 
# 							and folder e.g  restore list etc.
# Added By                : Pooja Havaldar
#******************************************************************************************************************/
function removeBackupTempFiles()
{
	GLOBAL $successFiles;
	GLOBAL $backupLocation;
	GLOBAL $backupUtfFile;
	GLOBAL $userDir;

	$dedupDetailFile = $userDir.PATHSEPARATOR.DEDUP_DETAIL_FILE;
	$deviceID = "";
	$restoreList = "";
	if(file_exists($dedupDetailFile)){
		$deviceID = file_get_contents($dedupDetailFile);
		$deviceID = trim($deviceID);
	}
	
	#If backup success, then .RestoreList and Search list gets cleaned up
	if(0 < $successFiles){
		$rListPath = "$userDir/.RestoreList";
		$remoteSearchPath = "$userDir/Restore/.+searchList/*";
		$backupLocation = str_replace("\'","'\\''",$backupLocation);
		if($deviceID) 
			$restoreList = $rListPath."/".$deviceID;
		else 
			$restoreList = $rListPath.$backupLocation;
		$rem = "rm -rf '$restoreList' '$remoteSearchPath' " . PROGRESS_PATH;
		`$rem`;
	}
	
	if(file_exists(TOTAL_SIZE_PATH))
		@unlink(TOTAL_SIZE_PATH);

	if(file_exists(STATUSFILE))
		@unlink(STATUSFILE);

	if(file_exists($backupUtfFile))
		@unlink($backupUtfFile);

	if(file_exists(OUTPUTFILE))
		@unlink(OUTPUTFILE);
	
	if(file_exists(ERRORFILE))
		@unlink(ERRORFILE);

	if(file_exists(CANCEL_PATH))
		@unlink(CANCEL_PATH);
	
	if(file_exists(INFOFILE))
		@unlink(INFOFILE);

	if(file_exists(RETRY_INFOFILE))
		@unlink(RETRY_INFOFILE);
	
	if(file_exists(EXEC_ERRORFILE))
		@unlink(EXEC_ERRORFILE);

	shell_exec("rm -rf ".TEMP_FILES." ".ERROR_DIR);
}

#****************************************************************************************************
# Subroutine Name         : writeLogHeader.
# Objective               : This function will write the Log header details in the the output file 
# Added By                : Pooja Havaldar
# Modified by	 		  :  
#*****************************************************************************************************/
function writeLogHeader()
{
	GLOBAL $relative, $logOutputFilePath;
	GLOBAL $headerMsg, $username, $hostName, $hidden, $backupLocation;
	
	$temp = "";
	$logheader = "";
	if($relative == 1)
		$temp = "Mirror";
	else
		$temp = "Relative";
	
	# require to open log file to show job in progress as well as to log exclude details
	$logOutputHandle = fopen($logOutputFilePath, 'a+');
	if($logOutputHandle){
		# As log file is opened so create logpid file as well 
		$currPath = trim(getcwd());
		if(file_put_contents(LOGPIDFILE,"$currPath/$logOutputFilePath"))
			chmod(LOGPIDFILE,PERMISSIONVAL);
		else {
			$errStr = "Unable to open file ".LOGPIDFILE.", Reason:".customErrorMsg();
			fwrite($logOutputHandle,$errStr.PHP_EOL);
			fclose($logOutputHandle);
			traceLog($errStr);
			exit_cleanup();
			exit;
	}
			@chmod($logOutputFilePath,PERMISSIONVAL);
	}
	else {
		$errStr = "Failed to create $logOutputFilePath, Reason:".customErrorMsg();
		traceLog($errStr);
		exit_cleanup();
		exit;
	}
		
	# construct log header.
	//$headerMsg = "Backup Start Time: ".WHITESPACE.date("D M d H:i:s Y").LINEFEED;
	$headerMsg = "Backup Start Time: ".WHITESPACE.trim(shell_exec('date +"%a %b %d %T %Y"')).LINEFEED;
	$logheader = $headerMsg.LINEFEED."User name: ".$username.LINEFEED;
	
	$headerMsg .= getHeaderMsg($temp, $hidden);
	$headerMsg .= 	"Backup Location: ".$backupLocation.LINEFEED;	
	$logheader .= getHeaderMsg($temp, $hidden);
	$logheader .= 	"Backup Location: ".$backupLocation.LINEFEED.LINEFEED;	
					
	# write log header.
	fwrite($logOutputHandle,$logheader.PHP_EOL);
	if($logOutputHandle)
		fclose($logOutputHandle);
}

#****************************************************************************************************
# Subroutine Name         : exit_cleanup.
# Objective               : This function will execute the major functions required at the time of exit 
# Added By                : Deepak Chaurasia
# Modified by	 		  : Pooja Havaldar 
#*****************************************************************************************************/
function exit_cleanup()
{
	GLOBAL $successFiles;
	GLOBAL $syncedFiles;
	GLOBAL $failedFiles;
	GLOBAL $exit_flag;
	GLOBAL $cancelFlag;
	GLOBAL $errStr;
	
	$successFiles = getParameterValueFromStatusFile("BACKUP_COUNT_FILES_INDEX");
	$syncedFiles = getParameterValueFromStatusFile("SYNC_COUNT_FILES_INDEX");
	$failedFiles = getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");
	$exit_flag = getParameterValueFromStatusFile("EXIT_FLAG_INDEX");

	$exit = preg_split('/-/', $exit_flag,2);
	if($exit[0] && $exit[1] != "")
		$errStr = $exit[1];
	
	if(file_exists(PIDFILE)){
		@unlink(PIDFILE);
		if(file_exists(EVS_TEMP))
			exec("rm -rf ".EVS_TEMP);
	}
	else {
 		# In childprocess, if we exit due to some exit scenario, then this exit_flag will be true with error msg
		$cancelFlag = true;
		if(!$exit[0])
			$errStr = readFromUserCancel();
		traceLog("$errStr");
	}
	
	writeOperationSummary(BACKUP);
	getOperationStatus();
	updateLogFileName();
	sendMail();	
	removeBackupTempFiles();
	@unlink(STARTPIDFILE);
}
?>
