<?php
define('PERMISSIONVAL',0777);
define('TOTAL_SIZE_PATH','totalsize.txt');
define('INFOFILE', "tempfiles/info_file");
define('NORELATIVE', "--no-relative");
$processName 				= "main";
$filesonly 					= 0;
$restoreDisplayPath 		= "./RestoresetFileForDisplay.txt";
$periodOperator 			= ".";
$operationComplete 			= "100";
$idevsutilCommandLine 		= '';
$pid_OutputProcess 			= '';
$filesConsideredCount 		= '';
$restoreExit 				= false;
$headerWrite 				= 0;
$filecount 					= 0;
$exitStatus 				= 0;
$Restorefilecount 			= 0;
$relative 					= 0;
$current_source 			= "";
$next_source 				= "";
$filehandle 				= '';
$restore_errorfile 			= "RESTORE_ERRORFILE";
$filesOnlyFile_count 		= 0;
$RestoreFile 				= "";
$restoreUtfFile 			= "";
$RestoresetFile_norelative 	= TEMP_FILES.PATHSEPARATOR.RESTORESETFILE_NORELATIVE;
$RestoresetFile_filesOnly	= TEMP_FILES.PATHSEPARATOR.RESTORESETFILE_ONLYFILES;
$RestoresetFile_relative 	= TEMP_FILES.PATHSEPARATOR.RESTORESETFILE_RELATIVE;
$fileOnlySetName 			= $RestoresetFile_filesOnly;
$noRelIndex 				= 0;
$isErrorFileOpen 			= 1;
$fileJobTerminationPath 	= $webDir.PATHSEPARATOR.APPDIR.PATHSEPARATOR.SCRIPTS.PATHSEPARATOR.JOBTERMINATIONFILE;
$ErrorArgumentsExit 		= array(
									"No route to host",
									"not enough free space on device",
									"Input/output error",
									"invalid source path for operation",
									"Device not configured",
									"failed to get the device information",
									"encryption verification failed"
								);
$operationStartTimeRestore 	= time();

# If job in progress then don't run again
$jobDir 					= $jobrunningDir."/";
$varManualTask 				= '+ManualTask/';
$varTrashManualTask 		= '+TrashManualTask/';

# String to be logged when user cancels job
$cancelStr 					= "";

# Output File Name
$outputFileName 			= "RESTORE";

# Count of files which could not be backed up/synced due to unspecified errors 
$countOtherErrors 			= 0;

#Checking whether current job is ManualTask or Scheduled
if(strpos( $jobDir, $varManualTask ) === false && strpos( $jobDir, $varTrashManualTask ) === false)
	$taskType = SCHEDULED;

#Checking whether current job is from Trash or not 
if (strpos( $jobDir, $varTrashManualTask ) !== false)
	$trash = 1;

$rel_Data 					= "";
if($isLocalRestore != 1)
{
	# hard coded for now.
	$rel_Data = NORELATIVE;
}
else
{
	# offline only --relative.
	$rel_Data = RELATIVE;
	$relative 		= 1;
	$current_source = "/";
}

$hostName 			= getRestoreLocation();
$sourceIdx 			= 0;

#******************************************************************************************************************
# Subroutine Name         : removeRestoreTempFiles.
# Objective               : This subroutine remove temporary files and folder. Also cleanup condition based files 
# 							and folder e.g local search etc.
# Added By                : Vijay Vinoth
#******************************************************************************************************************/
function removeRestoreTempFiles()
{
	GLOBAL $successFiles;
	GLOBAL $userDir;
	
	if(file_exists(STATUSFILE))
		unlink(STATUSFILE);
	
	# cleanup local search data.
	if($successFiles > 0){
		$localSearchPath = $userDir.PATHSEPARATOR.BACKUP.PATHSEPARATOR.".+searchList/*";
		exec("/bin/rm -rf $localSearchPath");
	}
 
	# cleanup intermediate files and folder.
	exec("rm -rf ".EXEC_ERRORFILE.WHITESPACE.ERROR_DIR.WHITESPACE.TEMP_FILES.WHITESPACE."search". WHITESPACE. PROGRESS_PATH.WHITESPACE.TOTAL_SIZE_PATH);
}

#****************************************************************************************************
# Subroutine Name         : generateRestoresetFiles.
# Objective               : Generating restore set file/files based on user's restore set file
#							content. Check for file/folder type based on that, if entry element of 
#							restore set file is folder then execute search command to get the list of 
#							files associated with that folder. Count number for files considered for 
#							restore. Write the required data to info_file.
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function generateRestoresetFiles()
{
	GLOBAL $isLocalRestore,		$databaseLB;
	GLOBAL $RestoreFile,				$totalFiles;
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $filesonlycount,		$relative,			$filecount;
	GLOBAL $restoreDisplayPath,	$outputErrorFile,	$isErrorFileOpen;
	GLOBAL $errorFile,					$openRestoreFileOrg;
	GLOBAL $RestoresetFile_filesOnly, 	$dbh_LB, 				$current_source,	$totalSize;
	GLOBAL $RestoresetFile_relative, $filehandle, $RestoresetFile_filesOnly;
	
	$processName 		= "generate";
	$result 			= -1;
	$res 				= "";
	$totalSize 			= 0;
	$outputErrorFile 	= fopen($errorFile, 'w');
	$filesonlycount = 0;
	$idx 			= 0;
	
	if($relative == 1){
		$filehandle 	= fopen($RestoresetFile_relative, "w");
		if(!$filehandle)
			traceLog("Unable to open file $RestoresetFile_relative to write, Reason: ".customErrorMsg());
		$RestoreFile 	=  $RestoresetFile_relative;
	}
	else {
		$filehandle 	= fopen($RestoresetFile_filesOnly, "w");
		if(!$filehandle)
			traceLog("Unable to open file $RestoresetFile_filesOnly to write, Reason: ".customErrorMsg());
		$RestoreFile 	=  $RestoresetFile_filesOnly;
	}
	@chmod($RestoreFile,PERMISSIONVAL);

	if(!$outputErrorFile)
	{
		$isErrorFileOpen = 0;
		traceLog("Unable to open $errorFile to write, Reason:".customErrorMsg());
	}
	
	# Read restore set display file to get information about file or folder.
	$RestoreDispArray = file($restoreDisplayPath);
	
	if(!$RestoreDispArray)
	{
		$errStr = "\n Cannot open file $restoreDisplayPath, Reason: ".customErrorMsg().LINEFEED;
		
		generateRestoresetErrorFiles($errStr);
		return;
	}
		
	# open DB connection
	if($isLocalRestore == 1)
	{
		if(!file_exists($databaseLB))
		{
			generateRestoresetErrorFiles($errStr);
			return;
		}		
		if(!createLBDB())
		{
			traceLog("Create LBDB failed.");
			generateRestoresetErrorFiles($errStr);
			return;
		}
		# create file for original file name set
		$openRestoreFileOrg = fopen($RestoreFile."_org", 'w');
		if(!$openRestoreFileOrg)
		{
			$errStr = "Cannot open $RestoreFile"."_org to write.".LINEFEED;
			generateRestoresetErrorFiles($errStr);
			return;
		}
	}

	# check for version restore.
	if(preg_match('/_IBVER+\d$/',trim($RestoreDispArray[0])))
	{
		$outputFile = fopen($RestoreFile, 'a+');
		fwrite($outputFile,trim($RestoreDispArray[0]).PHP_EOL);
		$filesonlycount++;
		$totalFiles++;
		generateRestoresetErrorFiles();
		return;
	}

	$RestoreDispArrayCount = count($RestoreDispArray);
	
	for ($idx = 1; $idx <= $RestoreDispArrayCount; $idx +=2 )
	{
		if(!file_exists(PIDFILE))
			break;

		if(preg_match('/^$/',trim($RestoreDispArray[$idx - 1]))|| preg_match('/^$/',trim($RestoreDispArray[$idx])))
			continue;

		$result = true;
		# check from restore display file that it is folder.
		if(trim($RestoreDispArray[$idx]) == FOLDER)
		{
			$result = createRestoreSetFromFolder(trim($RestoreDispArray[$idx - 1]));
			if($result == false)
			{
				$errStr = "Check from restore display file that it is folder failed".LINEFEED;
				generateRestoresetErrorFiles($errStr);
				return;
			}
		}	
		else 
		{
			if($isLocalRestore == 0)
				$RestoreFile = $RestoresetFile_filesOnly;
			
			$result 		= createRestoreSetFromFile(trim($RestoreDispArray[$idx - 1]));
			if($result == false){
				$errStr = "Intermediate restore file set creation failed".LINEFEED;
				generateRestoresetErrorFiles($errStr);
				return;
			}
			
			$propertyUtf8 	= getOperationFile(PROPERTIES, trim($RestoreDispArray[$idx - 1]));
			
			# EVS command to execute for properties
			$propertiesCmd 	= $idevsutilBinaryPath.WHITESPACE.IDEVSUTIL_ARG.ASSIGNMENTOP."\"$propertyUtf8\"";
			$out 			= exec("$propertiesCmd 2>".EXEC_ERRORFILE);
			$out = trim($out,"\n");
			$tmpArr = preg_match("/\d+/", $out, $matches);
			if(!isset($matches[0])){
				if(customFileSize(ERRORFILE) > 0)
				{
					$error = file_get_contents(ERRORFILE);
					checkDedupDeviceError($error);
				}
			} else			
				$totalSize 		+= trim($matches[0]);
			
		}
	}
	
	# create totalsize.txt
	$totalFileSize = fopen(TOTAL_SIZE_PATH, 'w+');
	
	if($totalFileSize)
	{
		fwrite($totalFileSize,$totalSize);
		fclose($totalFileSize);
	} 
	else
		traceLog("Can not open ".TOTAL_SIZE_PATH.", Reason: ".customErrorMsg().LINEFEED);

	generateRestoresetErrorFiles();
}

#****************************************************************************************************
# Subroutine Name         : generateRestoresetErrorFiles.
# Objective               : This subroutine is for error handling of generateRestoreset function
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function generateRestoresetErrorFiles($errStr = '')
{
	GLOBAL $isLocalRestore,	$databaseLB;
	GLOBAL $RestoreFile,		$totalFiles;
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $filesonlycount,		$relative,			$filecount;
	GLOBAL $filehandle,			$outputErrorFile,	$fileOnlySetName;
	GLOBAL $current_source,		$isErrorFileOpen,	$errorFile;
	GLOBAL $openRestoreFileOrg,	$dbh_LB,				$failedFilesCount,	$outputFile, $logOutputHandle;
	
	if($relative == 1 and $filecount == 0)
		@unlink($RestoreFile);
	else if($filesonlycount == 0)
		@unlink($fileOnlySetName);
	
	@chmod(INFOFILE,PERMISSIONVAL);
	$fd_write= fopen(INFOFILE, 'a');
	
	if($relative == 1 and $filecount > 0)
		fwrite($fd_write, "$RestoreFile ".RELATIVE." $current_source \n");
	else if($filesonlycount >0)
	{
		$current_source = "/";
		fwrite($fd_write, "$fileOnlySetName ".NORELATIVE." $current_source\n");
	}
	
	fwrite($fd_write, "TOTALFILES $totalFiles\n");
	fwrite($fd_write, "FAILEDCOUNT $failedFilesCount");
	fclose($fd_write);
	
	if($isErrorFileOpen)
		@fclose($outputErrorFile);
	
	if($outputFile)
		@fclose($outputFile);

	if($logOutputHandle)
		@fclose($logOutputHandle);
	
	if($openRestoreFileOrg)
		@fclose($openRestoreFileOrg);
	
	if($filehandle)
		@fclose($filehandle);
	
	# close DB connection for offline restore
	if($dbh_LB)
		unset($dbh_LB);
	
	# write $errStr to status file.
	if($errStr != "")
		writeErrorMsgToStatusFile($errStr);
}

#****************************************************************************************************
# Subroutine Name         : createRestoreSetFromFile.
# Objective               : Take remote folder as argument and execute serach/DB query on that
#							Create set of 1k files. Count number of files considered for restore.
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function createRestoreSetFromFile($fileName)
{	
	GLOBAL $isLocalRestore,	$RestoreFile,	$current_source,	$totalFiles;
	GLOBAL $relative,		$filesonlycount,$filecount;
	
	#if offline fire sqlite sql query and construct restore set file content.
	if($isLocalRestore == 1)
	{
		if(LOCAL_FILE_FOLDER_SELECT_FAILURE == writeActualAndEncSet($fileName))
		{
			//traceLog("Local file/folder search failed for [".$fileName."]");
			appendEnumerationError($fileName);
			return true;
		}
	}
	else
	{
		$totalFiles++;
		$fd_write 		= fopen($RestoreFile, 'a+');
		fwrite($fd_write,$fileName.PHP_EOL);
		$current_source = "/";
	}
	
	if($relative == 0)
	{
		$filesonlycount++;
		$filecount = $filesonlycount;
	}
	else 
		$filecount++;
	
	if($filecount == FILE_MAX_COUNT){
		if(!createRestoreSetFiles1k("FILESONLY"))
			return false;
	}
	
	return true;
}

#****************************************************************************************************
# Subroutine Name         : writeErrorMsgToStatusFile.
# Objective               : append errStr message to STATUS_FILE file.
# Added By                : Vijay Vinoth.
#****************************************************************************************************/
function writeErrorMsgToStatusFile($errStr)
{
	GLOBAL $statusFileHash;	
	$Restorecount = $Synccount = $failedcount = $failed_index = 0;
		
	# read the restore, sync, error count and restore termination status from status file
	if(file_exists(STATUSFILE))
	{
		$Restorecount 	= getParameterValueFromStatusFile("RESTORE_COUNT_FILES_INDEX");
		$Synccount 		= getParameterValueFromStatusFile("SYNC_COUNT_FILES_INDEX");
		$failedcount 	= getParameterValueFromStatusFile("FAILED_COUNT_FILES_INDEX");
		$failed_index 	= getParameterValueFromStatusFile("FILE_COUNT_INDEX");
	}
		
	# open status file to modify
	$restoreExit 		= true ."-$errStr";
	$statusFile 		= fopen(STATUSFILE, 'w+');
	
	if($statusFile)
	{
		fwrite($statusFile,"RESTORE_COUNT_FILES_INDEX = $Restorecount \n");
		fwrite($statusFile,"SYNC_COUNT_FILES_INDEX = $Synccount \n");
		fwrite($statusFile,"FAILED_COUNT_FILES_INDEX = $failedcount \n");
		fwrite($statusFile,"FILE_COUNT_INDEX = $failed_index \n");
		fwrite($statusFile,"RESTORE_TERMINATION_INDEX = $restoreExit");
		fclose($statusFile);
		chmod (STATUSFILE,PERMISSIONVAL) ;
		$statusFileHash=array();	
	}
	else
	{
		traceLog("Failed to open ".STATUSFILE.", Reason:".customErrorMsg());
		return;
	}
}

#****************************************************************************************************
# Subroutine Name         : createRestoreSetFiles1k.
# Objective               : Construct the restore set file/files based on relative or no relative.
# Added By                : Pooja Havaldar
# Modified By			  : Vijay Vinoth.
#*****************************************************************************************************/
function createRestoreSetFiles1k($filesOnly_flag='')
{
	GLOBAL $Restorefilecount,			$relative,		$filesonly,		$RestoreFile;
	GLOBAL $filesOnlyFile_count,		$filehandle,	$fileOnlySetName;
	GLOBAL $current_source,$noRelIndex;
	GLOBAL $openRestoreFileOrg,			$filecount,		$filesonlycount,$RestoresetFile_filesOnly;
	GLOBAL $RestoresetFile_relative,	$RestoresetFile_norelative;
	
	$Restorefilecount++;	
	session_write_close();
	
	if($relative == 0)
	{
		if($filesOnly_flag == "FILESONLY")
		{
			$filesonly 			= 1;
			$filesOnlyFile_count++;

			file_put_contents(INFOFILE,"$fileOnlySetName ".NORELATIVE." $current_source\n",FILE_APPEND);
			$fileOnlySetName 	= $RestoresetFile_filesOnly."_".$filesOnlyFile_count;
			$filesonlycount 	= 0;
			
			if(!is_writable($fileOnlySetName))
			{
				traceLog("Unable to open file $fileOnlySetName, Reason: ".customErrorMsg());
				return 0;
			}
		}
		else 
		{
			fclose($filehandle);
			file_put_contents(INFOFILE,"$RestoreFile ".RELATIVE." $current_source\n",FILE_APPEND);
			@chmod(INFOFILE,PERMISSIONVAL);	
			$RestoreFile 	= $RestoresetFile_norelative."$noRelIndex"."_$Restorefilecount";
			$filehandle 	= fopen($RestoreFile,"w");
			@chmod($RestoreFile,PERMISSIONVAL);	
			if(!$filehandle)
			{
				traceLog("Unable to open file $RestoreFile, Reason: ".customErrorMsg());
				return 0;
			}	
		}
	}
	else 
	{
		file_put_contents(INFOFILE,"$RestoreFile ".RELATIVE." $current_source\n",FILE_APPEND);
		@chmod(INFOFILE,PERMISSIONVAL);	
		$RestoreFile = $RestoresetFile_relative."_$Restorefilecount";
		@chmod($RestoreFile,PERMISSIONVAL);	
		
		if(!is_writable($RestoreFile))
		{
			traceLog("Unable to open file $RestoreFile, Reason: ".customErrorMsg());
			return 0;
		}
		
		if($isLocalRestore == 1)
		{
			fclose($openRestoreFileOrg);
			$openRestoreFileOrg = fopen($RestoreFile."_org","a");
			if(!$openRestoreFileOrg)
			{
				traceLog("Can't open $RestoreFile"."_org to write, Reason: ".customErrorMsg());
				return 0;
			}
		}
	}
	
	$filecount = 0;
	return CREATE_THOUSANDS_FILES_SET_SUCCESS;
}

#****************************************************************************************************
# Subroutine Name         : writeActualAndEncSet.
# Objective               : write actual file name to actual file set amd fire sql query, construct
#							enc path then write to enc set file. 
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function writeActualAndEncSet($fileName)
{	
	GLOBAL $dbh_LB,		$current_source,	$totalFiles,	$RestoreFile;
	GLOBAL $filecount;
	$fileNameInput 	= $fileName;
	$ridx 			= strrpos($fileName, "/");
	$folderPath 	= substr($fileName, 0, $ridx+1);
	$fileName 		= substr($fileName, $ridx+1);
	$preStatement 	= "";
	$statement 		= "select FOLDER_ID, ENC_NAME from ibfile where NAME=? AND DIRID=(select DIRID from ibfolder where NAME=?)";
	
	try
	{
		if($dbh_LB)
		{
			$preStatement 	= $dbh_LB->prepare($statement);
			$fileName 		= "'$fileName'";
			$folderPath 	= "'$folderPath'";
			$status 		= $preStatement->execute(array($fileName,$folderPath));	
		} else 
		{
			//print "No handle";
		}
	} 
	catch (PDOException $e)
	{
	
		$errStr = "Couldn't prepare statement.";
		//traceLog("Can't execute SELECT query, Reason: ".$e->getMessage());
	}
	
	$row = $preStatement->fetch();
	
	if(empty($row))
	{
		$errStr = "Couldn't prepare statement.";
		return LOCAL_FILE_FOLDER_SELECT_FAILURE;
		//traceLog($errStr);		
	}
	$startIndex 	= strpos ($fileNameInput, '/',1);
	$next_source 	= substr($fileNameInput, 0, $startIndex);
					
	if($current_source != $next_source)
	{
		if($filecount > 0)
		{
			if(!createRestoreSetFiles1k(""))
			{
				return false;
			}
		}
		$current_source = $next_source;
	}
	
	$totalFiles++;
	$folderId 	= $row[0];
	$encName 	= $row[1]; 
	file_put_contents($RestoreFile."_org",$fileNameInput.LINEFEED,FILE_APPEND);
	file_put_contents($RestoreFile,"/$folderId/$encName".LINEFEED,FILE_APPEND);
	@chmod($RestoreFile,PERMISSIONVAL);
	return LOCAL_SELECT_SUCCESS;
}

#****************************************************************************************************
# Subroutine Name         : enumerateLocal.
# Objective               : Take localfolder as argument and execute sqlite query on that. Create set of 1k 
#							files. Count number of files considered for restore.
# Added By                : Vijay Vinoth.
#*****************************************************************************************************/
function enumerateLocal($dirName)
{
	GLOBAL $dbh_LB,	$RestoreFile,	$filecount,	$totalFiles;
	
	$statementNew = "SELECT FOLDER_ID, ENC_NAME, ibfile.NAME, ibfolder.NAME from ibfile INNER JOIN ibfolder ON ibfolder.DIRID = ibfile.DIRID where ibfolder.NAME like ?";
	
	try
	{
		$preStatementNew 	= $dbh_LB->prepare($statementNew);
		$dirName 			= "'$dirName/%";
		$preStatementNew->execute(array($dirName));	
	} 
	catch (PDOException $e)
	{
		//traceLog("Can't execute SELECT query, Reason: ".$e->getMessage());
		return LOCAL_FILE_FOLDER_SELECT_FAILURE;
	}	
	
	while($folderIdEncActNamerow = $preStatementNew->fetch())
	{
		$folderName = substr($folderIdEncActNamerow[3], 1, -1);
		$fileName 	= substr($folderIdEncActNamerow[2], 1, -1);

		# write actual file name to restore_org file
		file_put_contents($RestoreFile."_org",$folderName.$fileName.LINEFEED,FILE_APPEND);
		@chmod($RestoreFile."_org",PERMISSIONVAL);

		# write encrypted file name to restore file
		file_put_contents($RestoreFile,"/$folderIdEncActNamerow[0]/$folderIdEncActNamerow[1]".LINEFEED,FILE_APPEND);
		@chmod($RestoreFile,PERMISSIONVAL);
		
		$totalFiles++;
		$filecount++;	

		if($filecount == FILE_MAX_COUNT)
		{
			if(!createRestoreSetFiles1k(""))
			{
				return THOUSANDS_FILES_SET_ERROR;
			}
		}
	}
	
	return LOCAL_SELECT_SUCCESS;
}

#****************************************************************************************************
# Subroutine Name         : createRestoreSetFromFolder.
# Objective               : Take remote folder as argument and execute serach/DB query on that
#							Create set of 1k files. Count number of files considered for restore.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
function createRestoreSetFromFolder($dirName)
{
	GLOBAL $RestoresetFile_norelative,	$noRelIndex,	$isLocalRestore, 	$filecount;
	GLOBAL $relative,		$filehandle,		$current_source;
	GLOBAL $RestoreFile;
	
	$errStr = "";
	
	if($relative == 0)
	{
		$Restorefilecount 	= 0;
		$noRelIndex++;
		$RestoreFile 		= $RestoresetFile_norelative."$noRelIndex";
		$filecount 			= 0;
		$sourceIdx 			= strrpos($dirName, "/");
		$source[$noRelIndex]= substr($dirName, 0, $sourceIdx);
		
		if($source[$noRelIndex] == "")
			$source[$noRelIndex] = "/";
		
		$current_source 	= $source[$noRelIndex];		
		$filehandle 		= fopen($RestoreFile,"w");
		@chmod($RestoreFile,PERMISSIONVAL);	
		if(!$filehandle)
		{
			$errStr = "Cannot open file $RestoreFile, Reason: ".customErrorMsg();
			traceLog($errStr);
			return false;
		}
	}
	
	$resEnumerate 			= 0;
	
	if($isLocalRestore == 1)
	{
		$startIndex 		= strpos($dirName, "/",1);	
		if($startIndex == -1)
			$next_source 	= $dirName;
		else
			$next_source 	= substr($dirName, 0, $startIndex);
		
		if($current_source != $next_source)
		{
			if($filecount > 0)
			{
				if(!createRestoreSetFiles1k(""))
					return false;
				}
			$current_source = $next_source;
		}
		$resEnumerate = enumerateLocal($dirName);
	}
	else 
		$resEnumerate = enumerateRemote($dirName);
	
	if(!$resEnumerate)
		return false;
	
	else if(REMOTE_SEARCH_CMD_ERROR == $resEnumerate || REMOTE_SEARCH_FAIL == $resEnumerate || REMOTE_SEARCH_OUTPUT_PARSE_FAIL == $resEnumerate || LOCAL_FILE_FOLDER_SELECT_FAILURE == $resEnumerate)
		appendEnumerationError($dirName);
	else if(REMOTE_SEARCH_THOUSANDS_FILES_SET_ERROR == $resEnumerate)
		return false;		
	
	
	if($filecount == 0)
		@unlink($RestoreFile);
	
	if($relative == 0 and $filecount > 0){
		$FD_WRITE = fopen(INFOFILE, 'a');
			if(!$FD_WRITE)
				traceLog("Unable to open ".INFOFILE.", Reason: ".customErrorMsg());
		else{
				fwrite($FD_WRITE, "$RestoreFile ".RELATIVE." $current_source\n");
				fclose($FD_WRITE);
			}
			
		@chmod(INFOFILE,PERMISSIONVAL);
		$filecount = 0;
				
		if(ftell($filehandle) != -1)
			fclose($filehandle);
		}
	
	if($errStr != "")
		traceLog($errStr);
	return true;
}

#****************************************************************************************************
# Subroutine Name         : enumerateRemote.
# Objective               : Take remote folder as argument and execute serach on that. Create set of 1k 
#							files. Count number of files considered for restore.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
function enumerateRemote($remoteFolder,$retry = 0)
{	
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $relative,			$current_source;
	GLOBAL $RestoreFile,		$totalFiles,			$filecount;
	GLOBAL $totalSize, 			$dedupDetailFile,		$dedupRestoreDeviceID;
	
	$errStr = "";
	$searchForRestore 	= 1;
    # remove / from begining for folder to avoid // while creating utf8 file.
	if($retry == 0)
		$remoteFolder 		= substr($remoteFolder, 1);
	
	# final EVS command to execute
	if(!is_dir(SEARCH))
	{
		if(!mkdir(SEARCH, PERMISSIONVAL))
		{
			$errStr 	= "Cannot create search directory, Reason: ".customErrorMsg();
			traceLog("$errStr");
			return false;
		}
	}
	
	# get utf8 file for EVS search command execute.
	$searchUtfFile 	= getOperationFile(SEARCH, $remoteFolder, $searchForRestore);
	$searchUtfFile 	= "'".$searchUtfFile."'";	
	
	if(!chdir(SEARCH))
	{
		$errStr 	= "Cannot change directory to search, Reason: ".customErrorMsg()."\n";
		traceLog("$errStr");
		return 0;
	}
	
	$idevsutilCommandLine = $idevsutilBinaryPath.WHITESPACE.IDEVSUTIL_ARG.ASSIGNMENTOP.$searchUtfFile;
	# EVS command execute
	$res = `$idevsutilCommandLine`;
	
	$res = trim($res);
	if($res != '')
	{
		$errStr = "Search cmd error found\n";
		traceLog("$errStr");
		chdir(".."); 
		return REMOTE_SEARCH_CMD_ERROR;
	}
		
	# update server address if cmd failed due to wrong evs server address
	if(checkErrorAndUpdateServerAddr())
		enumerateRemote($remoteFolder,1);
	

	if(customFileSize(ERRORFILE) > 0)
	{
		$error = file_get_contents(ERRORFILE);
		checkDedupDeviceError($error);
		$errStr = "Remote folder enumeration has failed.\n";
		@unlink($searchUtfFile);
		chdir(".."); 
		return REMOTE_SEARCH_FAIL;
	}
	@unlink($searchUtfFile);
	
	$handle = fopen(OUTPUTFILE, "r");
	if(!$handle){
		chdir(".."); 
		return REMOTE_SEARCH_OUTPUT_PARSE_FAIL;
	}
	
	if(!chdir(".."))
	{
		//$errStr = "Cannot change directory to job directory, Reason: ".customErrorMsg();
		//traceLog("$errStr");
		return 0;
	}
	
	$itemsFound = '/files_found/';
	if(file_exists($dedupDetailFile))
		$itemsFound = '/items_found/';
	
	while(1){
		$buffer = fread($handle, LIMIT);
		if(!file_exists(PIDFILE))
			break;
		if(0 === strlen($buffer)){
			if(customFileSize(ERRORFILE)){
				$error = file_get_contents(ERRORFILE);
				checkDedupDeviceError($error);
				break;
			}
			sleep(WAIT_FOR);
			fseek($handle, 0, 1);		//to clear eof flag
			continue;
		}

		//need to check appending partial record to packet or to first line of packet
		if("" != $lastLine)
			$buffer = $lastLine.$buffer;

		if(!preg_match('/\n$/', $buffer)){
			$lastNewlinePos = strrpos($buffer, "\n");
			$resultList = substr($buffer,0,$lastNewlinePos+1);
			$lastLine   = substr($buffer,$lastNewlinePos+1);
		} else {
			$resultList = $buffer;
			$lastLine = '';
		}
		
		if(preg_match($itemsFound, $resultList))		
			$flag = 1;
		
		$noOfLines  = substr_count($resultList,"\n");
		$resultListXML = "<root>$resultList</root>";
		$xml = simplexml_load_string($resultListXML);
		if(!$xml){
			#traceLog("Not XML: \n \n".$resultListXML);
			continue;
		}
					
		foreach ($xml->item as $value)
		{				
			$fileName[5] 			= trim($value['fname']);
			$totalSize 				+= trim($value['size']);;
			$temp 					= $fileName[5];
			$quoted_remoteFolder 	= $remoteFolder;
			$quoted_current_source 	= $current_source;
			$quoted_remoteFolder 	= $quoted_remoteFolder."/";	
			
			if(strpos( $temp, $quoted_remoteFolder ) !== false)
			{
				if($relative == 0)
				{
					if($current_source != "/")
					{
						$temp = substr($temp, strlen($quoted_current_source));
						if($temp)
						{
							file_put_contents($RestoreFile,$temp.LINEFEED,FILE_APPEND);
							$totalFiles++;
							$filecount++;
						}
					}
					else 
					{
						file_put_contents($RestoreFile,$temp.LINEFEED,FILE_APPEND);
						$totalFiles++;
						$filecount++;
					}
				}
				else 
				{
					$current_source = "/";
					file_put_contents($RestoreFile,$temp.LINEFEED,FILE_APPEND);
					$totalFiles++;
					$filecount++;
				}
			}
			if($filecount == FILE_MAX_COUNT)
			{
				if(!createRestoreSetFiles1k(""))
				{
					traceLog($errStr);
					return REMOTE_SEARCH_THOUSANDS_FILES_SET_ERROR;
				}
			}
		}
		if($flag == 1)
			break;
	}

	@chmod($RestoreFile,PERMISSIONVAL);
	traceLog($errStr);
	return REMOTE_SEARCH_SUCCESS;
}