<?php
include 'fetchPath.php';
define('RESULTFILE', "result.txt");
define('COUNTFILE', "count.txt");
$lastLine = "";
$filename = "";
$hidden = "Enabled";
$totalFileCount = 0;
$notExistCount = 0;
$count = 0;
$excludePartialPath = $userDir.PATHSEPARATOR.EXCLUDE_PARTIALPATH;
$countArr = array();
$isFolderEmpty = true;
$errNo = 0;

if(file_exists($excludePartialPath)){
        $excludeParArray = file($excludePartialPath); #read the whole file into an array in a single stretch
	if(count($excludeParArray)){
        $tmp = trim($excludeParArray[0],LINEFEED);
        if($tmp == '\/.') 
			$hidden = "Disabled";
    }
}

#parsing output for search and finding list of missing files in local
$OUTPUTFILE = fopen(OUTPUTFILE,"r");
if(!$OUTPUTFILE){
	$errNo = 2;
	errorCleanup($errNo);
}

# create a file with item count of missing files locally
if(!file_exists(COUNTFILE)){
	if($COUNTFD = fopen(COUNTFILE,"w")){
		fclose($COUNTFD);
		chmod(COUNTFILE, PERMISSIONVAL);
	}
	else {
		traceLog("Unable to open file ".COUNTFILE);
		$errNo = 2;
		errorCleanup($errNo);
	}
}

# create a file with list of files missing locally
if(!$RESULT = fopen(RESULTFILE,"a")){
	traceLog("Unable to open file ".RESULTFILE);
	$errNo = 3;
	errorCleanup($errNo);
}
chmod(RESULTFILE,PERMISSIONVAL);

if($COUNT_FILE = fopen(COUNTFILE,"r")){
	$countArr = file(COUNTFILE);
	fclose($COUNT_FILE);
	$totalFileCount += $countArr[2];
	$notExistCount += $countArr[3];
}
else {
	traceLog("Unable to open file ".COUNTFILE);
	return;
}

while(1){
	$buffer = fread($OUTPUTFILE, LIMIT); 
	if(strlen($buffer) == 0){
		if(customFileSize(ERRORFILE)){
			$error = file_get_contents(ERRORFILE);
			checkDedupDeviceError($error);
			break;
		}
        
		if(!file_exists(PIDFILE)){
			traceLog(PIDFILE." does not exist.");
			$errNo = 4;
			errorCleanup($errNo);
		}
		
		sleep(1);
		fseek($OUTPUTFILE, 0, 1);		#to clear eof flag
		continue;
	}

	if(file_exists($dedupDetailFile)){
		//need to check appending partial record to packet or to first line of packet
		if($lastLine != "")
			$buffer = $lastLine.$buffer;

		if(!preg_match('/\n$/', $buffer)){
			$lastNewlinePos = strrpos($buffer, "\n");
			$resultList = substr($buffer,0,$lastNewlinePos+1);
			$lastLine   = substr($buffer,$lastNewlinePos+1);
		} else {
			$resultList = $buffer;
			$lastLine = '';
		}
		
		if(preg_match('/items_found/', $resultList))		
			$flag = 1;
		
		$noOfLines  = substr_count($resultList,"\n");
		$resultListXML = "<root>$resultList</root>";
		$xml = simplexml_load_string($resultListXML);
		if(!$xml){
			Scheduler::Log("Not XML: \n \n".$resultListXML);
			continue;
			//$resultListXML = checkAndConstructXML($resultList);
			//$resultListXML = "<root>".utf8_encode($resultListXML)."</root>";
			//$xml = simplexml_load_string($resultListXML);
		}
		foreach ($xml->item as $value)
		{
			if(isset($value['items_found']))
				break;
			
			$filename = trim($value['fname']);
			$itemType = trim($value['restype']);
			# check for file existance 
			if($filename != "" && $itemType  == "F"){
				if(preg_match("/\/\./",$filename) && ($hidden == 'Disabled'))
					continue;
				
				$totalFileCount++;
				if(!file_exists($filename)){
					# check if filename is starts with "/" and check for non admin permission
					if(preg_match("/^\//",$filename)){
						$notExistCount++;
						fwrite($RESULT,$filename.LINEFEED);
					}
					else 
						traceLog("Unable to consider for archive. item name: $filename and backupLocation: $backupLocation");
				} 
				else 
					$isFolderEmpty = false;
			
				$countArr[0] = $errNo;
				$countArr[1] = $filename;
				$countArr[2] = $totalFileCount;
				$countArr[3] = $notExistCount;
				updateCountFile($countArr);
			}
		}
	} else {
		#need to check appending partial record to packet or to first line of packet
		if($lastLine != "")
			$buffer = $lastLine . $buffer;
		
		$resultList = explode(LINEFEED,$buffer);
		$bufIndex = count($resultList);
		
		# In case of partial or line ending with new line both case we need to reduce the index by one
		$bufIndex--;
		
		if(!preg_match("/\n$/",$buffer))       #keep last line of buffer only when it not ends with newline.
			$lastLine = end($resultList);
		else
			$lastLine = "";
		
		$flag = 0;
		if(0 < $bufIndex and preg_match("/Total files found/",$resultList[$bufIndex-1])){
			$flag = 1;
			$bufIndex -= 1;
		}

		$backupLocation = "/".ltrim(readBackupLocation(),"/");
		$len = strlen($backupLocation);
		
		for($index = 0; $index < $bufIndex; $index++){
			$count++;
			if(!($count%10) && !file_exists(PIDFILE)){
				traceLog(PIDFILE." file does not exist.");
				$errNo = 4;
				$count = 0;
				errorCleanup($errNo);
			}
			
			$filename = "";	
			$fields = explode("] [",$resultList[$index],6);
			if(count($fields) < 6)
				continue;

			$fields[2] = ltrim($fields[2]);
			if($fields[2] != "0"){
				# remove backup location from beginning in string
				$fields[5] = substr($fields[5], $len);
				# remove last character ] from last field
				$fields[5] = preg_replace("/.$/","",$fields[5]);
				# remove spaces from beginning from required fields
				$fields[5] = ltrim($fields[5]);
				$filename = $fields[5];
				
				# check for file existance 
				if($filename != ""){	
					if(preg_match("/\/\./",$filename) && ($hidden == 'Disabled'))
						continue;
					
					$totalFileCount++;
					if(!file_exists($filename)){
						# check if filename is starts with "/" and check for non admin permission
						if(preg_match("/^\//",$filename)){
							$notExistCount++;
							fwrite($RESULT,$backupLocation.$filename.LINEFEED);
						}
						else 
							traceLog("Unable to consider for archive. item name: $filename and backupLocation: $backupLocation");
					} 
					else 
						$isFolderEmpty = false;
				
					$countArr[0] = $errNo;
					$countArr[1] = $filename;
					$countArr[2] = $totalFileCount;
					$countArr[3] = $notExistCount;
					updateCountFile($countArr);
				}
			}
		}
	}
	if(1 == $flag)
		break;
}
print $isFolderEmpty;
errorCleanup($errNo);

#****************************************************************************************************
# Subroutine Name         : errorCleanup
# Objective               : To complete the error cleanup
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
function errorCleanup($errNo)
{
	GLOBAL $countArr, $RESULT, $OUTPUTFILE;
	if($errNo == 0)
		$errNo = 1;
		
	$countArr[0] = $errNo;
	updateCountFile($countArr);
	fclose($RESULT);
	fclose($OUTPUTFILE);
	exit;
}

#****************************************************************************************************
# Subroutine Name         : updateCountFile
# Objective               : Update the count file with latest content
# Added By                : Kamalraj
#*****************************************************************************************************/
function updateCountFile($countArr=array())
{
    $countStr = trim(implode(LINEFEED,$countArr));
	file_put_contents(COUNTFILE,$countStr);
	@chmod(COUNTFILE,PERMISSIONVAL);
}
?>
